/***************************************************************************
 *   Copyright (C) 2005 by MMM   *
 *   mamuma@eresmas.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "ficha.h"

Ficha::Ficha()
{
   q=gluNewQuadric();
   puedemover=false;
   casillasamoverautomaticamente=-1;
   posicion_en_casilla=0;
   angulo_rotacion=0;
}


Ficha::~Ficha()
{
}


void Ficha::dibujar(int textura, GLfloat *escala,float velocidad_rotacion)
{
  this->angulo_rotacion=this->angulo_rotacion+velocidad_rotacion;

  glInitNames();
  glPushName(0);
  glPushMatrix();

  glTranslated(posicion[0],posicion[1],posicion[2]);
  if(escala){
    glScaled(escala[0],escala[1],escala[2]);
  }
/*
  GLfloat light_specular[] =  {.8, 0, 0 ,0};
  glMaterialfv(GL_FRONT,GL_SPECULAR,light_specular);
  glMateriali(GL_FRONT,GL_SHININESS,0);*/
  glColor4f(color[0],color[1],color[2],color[3]);
  //A�dir nombre a la ficha
  switch (this->id_jugador){
    case 0:
      switch(this->id){
        case 0:
          glPushName(B0);
          break;
        case 1:
          glPushName(B1);
          break;
        case 2:
          glPushName(B2);
          break;
        case 3:
          glPushName(B3);
          break;
      }
      break;
    case 1:
      switch(id){
        case 0:
          glPushName(R0);
          break;
        case 1:
          glPushName(R1);
          break;
        case 2:
          glPushName(R2);
          break;
        case 3:
          glPushName(R3);
          break;
      }
      break;
    case 2:
      switch(id){
        case 0:
          glPushName(G0);
          break;
        case 1:
          glPushName(G1);
          break;
        case 2:
          glPushName(G2);
          break;
        case 3:
          glPushName(G3);
          break;
      }
      break;
    case 3:
      switch(id){
        case 0:
          glPushName(Y0);
          break;
        case 1:
          glPushName(Y1);
          break;
        case 2:
          glPushName(Y2);
          break;
        case 3:
          glPushName(Y3);
          break;
      }
      break;
  }
   glBindTexture(GL_TEXTURE_2D, textura); 
  if(this->angulo_rotacion>0){
     glRotatef(this->angulo_rotacion,0,1.0,0);
//      printf("Mas\n");
  }else if(this->angulo_rotacion<0){
     glRotatef(this->angulo_rotacion,0,-1.0,0);
//      printf("Menos\n");
  }
   gluQuadricDrawStyle (q, GLU_FILL);
   gluQuadricNormals (q, GLU_SMOOTH);
   gluQuadricTexture (q, true);
  glTranslated(.4,.4,0);

   gluCylinder (q, .5, .5, .2, 15, 5);
  glTranslated(0, 0, .2);
  gluDisk(q, 0, .5, 15, 5);
  glPopName();
  glPopMatrix();
}

void Ficha::avion(void)
{
	glPushMatrix();
	GLTVector3 vNormal;	
   glTranslated(30,3,3);
   glScaled(.05,.05,.05);
   GLfloat light_specular[] ={.8, 0, 0 ,0};
   glColorMaterial(GL_FRONT,GL_AMBIENT_AND_DIFFUSE);
   glMaterialfv(GL_FRONT,GL_SPECULAR,light_specular);
   glMateriali(GL_FRONT,GL_SHININESS,128);
   glBegin(GL_TRIANGLES);
   glNormal3f(0.0f, -1.0f, 0.0f);
   glVertex3f(0.0f, 0.0f, 60.0f);
   glVertex3f(-15.0f, 0.0f, 30.0f);
   glVertex3f(15.0f,0.0f,30.0f);

                {
                GLTVector3 vPoints[3] = {{ 15.0f, 0.0f,  30.0f},
                                        { 0.0f,  15.0f, 30.0f},
                                        { 0.0f,  0.0f,  60.0f}};

                // Calculate the normal for the plane
                gltGetNormalVector(vPoints[0], vPoints[1], vPoints[2], vNormal);
		glNormal3fv(vNormal);
		glVertex3fv(vPoints[0]);
		glVertex3fv(vPoints[1]);
		glVertex3fv(vPoints[2]);
                }	


                {
                GLTVector3 vPoints[3] = {{ 0.0f, 0.0f, 60.0f },
                                        { 0.0f, 15.0f, 30.0f },
                                        { -15.0f, 0.0f, 30.0f }};

                gltGetNormalVector(vPoints[0], vPoints[1], vPoints[2], vNormal);
                glNormal3fv(vNormal);
		glVertex3fv(vPoints[0]);
		glVertex3fv(vPoints[1]);
		glVertex3fv(vPoints[2]);
                }


                // Body of the Plane ////////////////////////
                {
                GLTVector3 vPoints[3] = {{ -15.0f, 0.0f, 30.0f },
                                        { 0.0f, 15.0f, 30.0f },
				        { 0.0f, 0.0f, -56.0f }};

                gltGetNormalVector(vPoints[0], vPoints[1], vPoints[2], vNormal);
                glNormal3fv(vNormal);
		glVertex3fv(vPoints[0]);
		glVertex3fv(vPoints[1]);
		glVertex3fv(vPoints[2]);
                }
                	
                {
                GLTVector3 vPoints[3] = {{ 0.0f, 0.0f, -56.0f },
                                        { 0.0f, 15.0f, 30.0f },
                                        { 15.0f,0.0f,30.0f }};
	
                gltGetNormalVector(vPoints[0], vPoints[1], vPoints[2], vNormal);
                glNormal3fv(vNormal);
		glVertex3fv(vPoints[0]);
		glVertex3fv(vPoints[1]);
		glVertex3fv(vPoints[2]);
                }
                		
    
		glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(15.0f,0.0f,30.0f);
		glVertex3f(-15.0f, 0.0f, 30.0f);
		glVertex3f(0.0f, 0.0f, -56.0f);
    
                ///////////////////////////////////////////////
                // Left wing
                // Large triangle for bottom of wing
                {
                GLTVector3 vPoints[3] = {{ 0.0f,2.0f,27.0f },
                                        { -60.0f, 2.0f, -8.0f },
                                        { 60.0f, 2.0f, -8.0f }};

                gltGetNormalVector(vPoints[0], vPoints[1], vPoints[2], vNormal);
                glNormal3fv(vNormal);
		glVertex3fv(vPoints[0]);
		glVertex3fv(vPoints[1]);
		glVertex3fv(vPoints[2]);
                }
                
                        	
                {
                GLTVector3 vPoints[3] = {{ 60.0f, 2.0f, -8.0f},
					{0.0f, 7.0f, -8.0f},
					{0.0f,2.0f,27.0f }};
                
                gltGetNormalVector(vPoints[0], vPoints[1], vPoints[2], vNormal);
                glNormal3fv(vNormal);
		glVertex3fv(vPoints[0]);
		glVertex3fv(vPoints[1]);
		glVertex3fv(vPoints[2]);
                }
                
                {
                GLTVector3 vPoints[3] = {{60.0f, 2.0f, -8.0f},
					{-60.0f, 2.0f, -8.0f},
					{0.0f,7.0f,-8.0f }};

                gltGetNormalVector(vPoints[0], vPoints[1], vPoints[2], vNormal);
                glNormal3fv(vNormal);
		glVertex3fv(vPoints[0]);
		glVertex3fv(vPoints[1]);
		glVertex3fv(vPoints[2]);
                }
                
                {
                GLTVector3 vPoints[3] = {{0.0f,2.0f,27.0f},
                                        {0.0f, 7.0f, -8.0f},
                                        {-60.0f, 2.0f, -8.0f}};

                gltGetNormalVector(vPoints[0], vPoints[1], vPoints[2], vNormal);
                glNormal3fv(vNormal);
		glVertex3fv(vPoints[0]);
		glVertex3fv(vPoints[1]);
		glVertex3fv(vPoints[2]);
                }
                
                        
                // Tail section///////////////////////////////
                // Bottom of back fin
		glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(-30.0f, -0.50f, -57.0f);
		glVertex3f(30.0f, -0.50f, -57.0f);
		glVertex3f(0.0f,-0.50f,-40.0f);

                {
                GLTVector3 vPoints[3] = {{ 0.0f,-0.5f,-40.0f },
					{30.0f, -0.5f, -57.0f},
					{0.0f, 4.0f, -57.0f }};

                gltGetNormalVector(vPoints[0], vPoints[1], vPoints[2], vNormal);
                glNormal3fv(vNormal);
		glVertex3fv(vPoints[0]);
		glVertex3fv(vPoints[1]);
		glVertex3fv(vPoints[2]);
                }
                
                        
                {
                GLTVector3 vPoints[3] = {{ 0.0f, 4.0f, -57.0f },
					{ -30.0f, -0.5f, -57.0f },
					{ 0.0f,-0.5f,-40.0f }};

                gltGetNormalVector(vPoints[0], vPoints[1], vPoints[2], vNormal);
                glNormal3fv(vNormal);
		glVertex3fv(vPoints[0]);
		glVertex3fv(vPoints[1]);
		glVertex3fv(vPoints[2]);
                }


                {
                GLTVector3 vPoints[3] = {{ 30.0f,-0.5f,-57.0f },
					{ -30.0f, -0.5f, -57.0f },
					{ 0.0f, 4.0f, -57.0f }};

                gltGetNormalVector(vPoints[0], vPoints[1], vPoints[2], vNormal);
                glNormal3fv(vNormal);
		glVertex3fv(vPoints[0]);
		glVertex3fv(vPoints[1]);
		glVertex3fv(vPoints[2]);
                }
                
                {
                GLTVector3 vPoints[3] = {{ 0.0f,0.5f,-40.0f },
					{ 3.0f, 0.5f, -57.0f },
					{ 0.0f, 25.0f, -65.0f }};

                gltGetNormalVector(vPoints[0], vPoints[1], vPoints[2], vNormal);
                glNormal3fv(vNormal);
		glVertex3fv(vPoints[0]);
		glVertex3fv(vPoints[1]);
		glVertex3fv(vPoints[2]);
                }
                
                        
                {
                GLTVector3 vPoints[3] = {{ 0.0f, 25.0f, -65.0f },
					{ -3.0f, 0.5f, -57.0f},
					{ 0.0f,0.5f,-40.0f }};

                gltGetNormalVector(vPoints[0], vPoints[1], vPoints[2], vNormal);
                glNormal3fv(vNormal);
		glVertex3fv(vPoints[0]);
		glVertex3fv(vPoints[1]);
		glVertex3fv(vPoints[2]);
                }
                
                {
                GLTVector3 vPoints[3] = {{ 3.0f,0.5f,-57.0f },
					{ -3.0f, 0.5f, -57.0f },
					{ 0.0f, 25.0f, -65.0f }};

                gltGetNormalVector(vPoints[0], vPoints[1], vPoints[2], vNormal);
                glNormal3fv(vNormal);
		glVertex3fv(vPoints[0]);
		glVertex3fv(vPoints[1]);
		glVertex3fv(vPoints[2]);
                }
                
                
        glEnd();
                
    	// Restore the matrix state
	glPopMatrix();
}

/*!
    \fn Ficha::mover(int dado)
    Devuelve un booleano positivo si puede mover
Los filtros son internos a fichas
 */
bool Ficha::mover(int tirada){
   //Si esta en la casilla de incio la tirada se pasa de 5 a 1
   int tmptirada=tirada;
   if (this->posicion_ruta==0 && tirada==5){
     tmptirada=1;
     printf ("Jugador %d: Saco una ficha de la casilla inicial\n", this->id_jugador);
   }

   int casillaantesmover=this->ruta[this->posicion_ruta];

   if (this->posicion_ruta==72){
       return false;
   } else {
       if (this->posicion_ruta+tmptirada>72){
         return false;
       }else{
         this->posicion_ruta=this->posicion_ruta+tmptirada;
       }
   }

   if (this->posicion_en_casilla==1)  this->casillas[casillaantesmover].ocupada_posicion_ficha_1=false;   
   if (this->posicion_en_casilla==2)  this->casillas[casillaantesmover].ocupada_posicion_ficha_2=false;   
   if (this->posicion_en_casilla==3)  this->casillas[casillaantesmover].ocupada_posicion_ficha_3=false;   
   if (this->posicion_en_casilla==4)  this->casillas[casillaantesmover].ocupada_posicion_ficha_4=false;

   casillas[casillaantesmover].numfichas--;

   int casillaficha=this->ruta[this->posicion_ruta];
   this->setPosicion(casillas[casillaficha].getNuevaPosicion(this->posicion_en_casilla_inicial,this->posicion_en_casilla));
   return true;
}

/*!
	Se pone el cargando_xml_glparchis, porque lsa casilla antes de mover
   no existe en esa situaci�n
 */
int Ficha::mover_posicion_ruta(int posicionruta_antes, int posicionruta_despues){
   int casillaantesmover=this->ruta[posicionruta_antes];

   if (this->posicion_en_casilla==1)  this->casillas[casillaantesmover].ocupada_posicion_ficha_1=false;   
   if (this->posicion_en_casilla==2)  this->casillas[casillaantesmover].ocupada_posicion_ficha_2=false;   
   if (this->posicion_en_casilla==3)  this->casillas[casillaantesmover].ocupada_posicion_ficha_3=false;   
   if (this->posicion_en_casilla==4)  this->casillas[casillaantesmover].ocupada_posicion_ficha_4=false;

   casillas[casillaantesmover].numfichas--;

   int casillaficha=this->ruta[posicionruta_despues];

   this->setPosicion(casillas[casillaficha].getNuevaPosicion(this->posicion_en_casilla_inicial,this->posicion_en_casilla));

   this->posicion_ruta=posicionruta_despues;
//    this->id_casilla=casillaficha;
   return 0;
}


void Ficha::iniciar(int id)
{
  this->id=id;
}

/*!
    \fn Ficha::iniciar()
 */
void Ficha::iniciar(int id, Casilla *casillas)
{
  this->id=id;
  this->casillas=casillas;
  this->posicion_ruta=0;
  this->num_casillas_ruta=73;
  this->ruta=new int[this->num_casillas_ruta];
  switch(this->id_jugador){
    case 0: //Azul
      this->ruta[0]=101;
      this->ruta[1]=22;
      this->ruta[2]=23;
      this->ruta[3]=24;
      this->ruta[4]=25;
      this->ruta[5]=26;
      this->ruta[6]=27;
      this->ruta[7]=28;
      this->ruta[8]=29;
      this->ruta[9]=30;
      this->ruta[10]=31;
      this->ruta[11]=32;
      this->ruta[12]=33;
      this->ruta[13]=34;
      this->ruta[14]=35;
      this->ruta[15]=36;
      this->ruta[16]=37;
      this->ruta[17]=38;
      this->ruta[18]=39;
      this->ruta[19]=40;
      this->ruta[20]=41;
      this->ruta[21]=42;
      this->ruta[22]=43;
      this->ruta[23]=44;
      this->ruta[24]=45;
      this->ruta[25]=46;
      this->ruta[26]=47;
      this->ruta[27]=48;
      this->ruta[28]=49;
      this->ruta[29]=50;
      this->ruta[30]=51;
      this->ruta[31]=52;
      this->ruta[32]=53;
      this->ruta[33]=54;
      this->ruta[34]=55;
      this->ruta[35]=56;
      this->ruta[36]=57;
      this->ruta[37]=58;
      this->ruta[38]=59;
      this->ruta[39]=60;
      this->ruta[40]=61;
      this->ruta[41]=62;
      this->ruta[42]=63;
      this->ruta[43]=64;
      this->ruta[44]=65;
      this->ruta[45]=66;
      this->ruta[46]=67;
      this->ruta[47]=0;
      this->ruta[48]=1;
      this->ruta[49]=2;
      this->ruta[50]=3;
      this->ruta[51]=4;
      this->ruta[52]=5;
      this->ruta[53]=6;
      this->ruta[54]=7;
      this->ruta[55]=8;
      this->ruta[56]=9;
      this->ruta[57]=10;
      this->ruta[58]=11;
      this->ruta[59]=12;
      this->ruta[60]=13;
      this->ruta[61]=14;
      this->ruta[62]=15;
      this->ruta[63]=16;
      this->ruta[64]=17;
      this->ruta[65]=76;
      this->ruta[66]=77;
      this->ruta[67]=78;
      this->ruta[68]=79;
      this->ruta[69]=80;
      this->ruta[70]=81;
      this->ruta[71]=82;
      this->ruta[72]=83;
      break;
    case 1://rojo
      this->ruta[0]=102;
      this->ruta[1]=39;
      this->ruta[2]=40;
      this->ruta[3]=41;
      this->ruta[4]=42;
      this->ruta[5]=43;
      this->ruta[6]=44;
      this->ruta[7]=45;
      this->ruta[8]=46;
      this->ruta[9]=47;
      this->ruta[10]=48;
      this->ruta[11]=49;
      this->ruta[12]=50;
      this->ruta[13]=51;
      this->ruta[14]=52;
      this->ruta[15]=53;
      this->ruta[16]=54;
      this->ruta[17]=55;
      this->ruta[18]=56;
      this->ruta[19]=57;
      this->ruta[20]=58;
      this->ruta[21]=59;
      this->ruta[22]=60;
      this->ruta[23]=61;
      this->ruta[24]=62;
      this->ruta[25]=63;
      this->ruta[26]=64;
      this->ruta[27]=65;
      this->ruta[28]=66;
      this->ruta[29]=67;
      this->ruta[30]=0;
      this->ruta[31]=1;
      this->ruta[32]=2;
      this->ruta[33]=3;
      this->ruta[34]=4;
      this->ruta[35]=5;
      this->ruta[36]=6;
      this->ruta[37]=7;
      this->ruta[38]=8;
      this->ruta[39]=9;
      this->ruta[40]=10;
      this->ruta[41]=11;
      this->ruta[42]=12;
      this->ruta[43]=13;
      this->ruta[44]=14;
      this->ruta[45]=15;
      this->ruta[46]=16;
      this->ruta[47]=17;
      this->ruta[48]=18;
      this->ruta[49]=19;
      this->ruta[50]=20;
      this->ruta[51]=21;
      this->ruta[52]=22;
      this->ruta[53]=23;
      this->ruta[54]=24;
      this->ruta[55]=25;
      this->ruta[56]=26;
      this->ruta[57]=27;
      this->ruta[58]=28;
      this->ruta[59]=29;
      this->ruta[60]=30;
      this->ruta[61]=31;
      this->ruta[62]=32;
      this->ruta[63]=33;
      this->ruta[64]=34;
      this->ruta[65]=84;
      this->ruta[66]=85;
      this->ruta[67]=86;
      this->ruta[68]=87;
      this->ruta[69]=88;
      this->ruta[70]=89;
      this->ruta[71]=90;
      this->ruta[72]=91;
      break;
    case 2://Verde
      this->ruta[0]=103;
      this->ruta[1]=56;
      this->ruta[2]=57;
      this->ruta[3]=58;
      this->ruta[4]=59;
      this->ruta[5]=60;
      this->ruta[6]=61;
      this->ruta[7]=62;
      this->ruta[8]=63;
      this->ruta[9]=64;
      this->ruta[10]=65;
      this->ruta[11]=66;
      this->ruta[12]=67;
      this->ruta[13]=0;
      this->ruta[14]=1;
      this->ruta[15]=2;
      this->ruta[16]=3;
      this->ruta[17]=4;
      this->ruta[18]=5;
      this->ruta[19]=6;
      this->ruta[20]=7;
      this->ruta[21]=8;
      this->ruta[22]=9;
      this->ruta[23]=10;
      this->ruta[24]=11;
      this->ruta[25]=12;
      this->ruta[26]=13;
      this->ruta[27]=14;
      this->ruta[28]=15;
      this->ruta[29]=16;
      this->ruta[30]=17;
      this->ruta[31]=18;
      this->ruta[32]=19;
      this->ruta[33]=20;
      this->ruta[34]=21;
      this->ruta[35]=22;
      this->ruta[36]=23;
      this->ruta[37]=24;
      this->ruta[38]=25;
      this->ruta[39]=26;
      this->ruta[40]=27;
      this->ruta[41]=28;
      this->ruta[42]=29;
      this->ruta[43]=30;
      this->ruta[44]=31;
      this->ruta[45]=32;
      this->ruta[46]=33;
      this->ruta[47]=34;
      this->ruta[48]=35;
      this->ruta[49]=36;
      this->ruta[50]=37;
      this->ruta[51]=38;
      this->ruta[52]=39;
      this->ruta[53]=40;
      this->ruta[54]=41;
      this->ruta[55]=42;
      this->ruta[56]=43;
      this->ruta[57]=44;
      this->ruta[58]=45;
      this->ruta[59]=46;
      this->ruta[60]=47;
      this->ruta[61]=48;
      this->ruta[62]=49;
      this->ruta[63]=50;
      this->ruta[64]=51;
      this->ruta[65]=92;
      this->ruta[66]=93;
      this->ruta[67]=94;
      this->ruta[68]=95;
      this->ruta[69]=96;
      this->ruta[70]=97;
      this->ruta[71]=98;
      this->ruta[72]=99;
      break;
    case 3:
      this->ruta[0]=100;//Amarillo
      this->ruta[1]=5;
      this->ruta[2]=6;
      this->ruta[3]=7;
      this->ruta[4]=8;
      this->ruta[5]=9;
      this->ruta[6]=10;
      this->ruta[7]=11;
      this->ruta[8]=12;
      this->ruta[9]=13;
      this->ruta[10]=14;
      this->ruta[11]=15;
      this->ruta[12]=16;
      this->ruta[13]=17;
      this->ruta[14]=18;
      this->ruta[15]=19;
      this->ruta[16]=20;
      this->ruta[17]=21;
      this->ruta[18]=22;
      this->ruta[19]=23;
      this->ruta[20]=24;
      this->ruta[21]=25;
      this->ruta[22]=26;
      this->ruta[23]=27;
      this->ruta[24]=28;
      this->ruta[25]=29;
      this->ruta[26]=30;
      this->ruta[27]=31;
      this->ruta[28]=32;
      this->ruta[29]=33;
      this->ruta[30]=34;
      this->ruta[31]=35;
      this->ruta[32]=36;
      this->ruta[33]=37;
      this->ruta[34]=38;
      this->ruta[35]=39;
      this->ruta[36]=40;
      this->ruta[37]=41;
      this->ruta[38]=42;
      this->ruta[39]=43;
      this->ruta[40]=44;
      this->ruta[41]=45;
      this->ruta[42]=46;
      this->ruta[43]=47;
      this->ruta[44]=48;
      this->ruta[45]=49;
      this->ruta[46]=50;
      this->ruta[47]=51;
      this->ruta[48]=52;
      this->ruta[49]=53;
      this->ruta[50]=54;
      this->ruta[51]=55;
      this->ruta[52]=56;
      this->ruta[53]=57;
      this->ruta[54]=58;
      this->ruta[55]=59;
      this->ruta[56]=60;
      this->ruta[57]=61;
      this->ruta[58]=62;
      this->ruta[59]=63;
      this->ruta[60]=64;
      this->ruta[61]=65;
      this->ruta[62]=66;
      this->ruta[63]=67;
      this->ruta[64]=0;
      this->ruta[65]=68;
      this->ruta[66]=69;
      this->ruta[67]=70;
      this->ruta[68]=71;
      this->ruta[69]=72;
      this->ruta[70]=73;
      this->ruta[71]=74;
      this->ruta[72]=75;
      break;

  }
//       printf("Ficha iniciar %d",ruta[0]);
}
void Ficha::setPosicion(GLfloat *pos)
{
  this->copiar3(this->posicion,pos[0], pos[1], pos[2]);
}



/*!
    \fn Ficha::puede_mover()
 */
bool Ficha::puede_mover(int tirada)
{
// // //   //Se pone como true y si falla algn caso se devuelve false en ese s�
// // //   //No se puede mover de la casilla inicial si no es un 5
// // //   if (this->posicion_ruta==0 && tirada!=5)
// // //     return false; 
// // // 
// // // 
// // // 
// // //   //No se puede mover si llega al final
// // //   if (this->posicion_ruta+tirada>72)
// // //     return false; 
// // // 
// // //   //No se puede mover si el sitio a donde va est�ocupado
// // //     if(this->casillas[this->ruta[this->posicion_ruta+tirada]].numfichas==2){
// // //       if (this->posicion_ruta+tirada>0 && this->posicion_ruta+tirada<72){ //La casilla incial y final tienen 4
// // //         printf("No puede mover por estar ocupada la casilla\n");
// // //         return false;
// // //       }
// // //     }
// // //   //No se puede mover si hay barrera por medio
// // //   for (int i=1; i<=tirada;i++){
// // //       if(this->casillas[this->ruta[this->posicion_ruta+i]].tiene_barrera==true){
// // //         if (this->posicion_ruta+i>=72){
// // //           return true;
// // //         }else{
// // //           printf("No puede mover por haber una barrera\n");
// // //           return false;
// // //         }
// // //     }
// // //   }

  return true;
}



int Ficha::id_casilla(){
  return this->ruta[this->posicion_ruta];
}


/*!
    \fn Ficha::moviendo(int casillaorigen, int casilladestino, int &estado_eventos)
 */
void Ficha::moviendo(int casillaorigen, int casilladestino, float velocidad)
{
    /// @todo implement me
}
