/***************************************************************************
 *   Copyright (C) 2005 by Turulo   *
 *   mamuma@eresmas.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef JUGADOR_H
#define JUGADOR_H
#include "ficha.h"
#include "casilla.h"
#include "objeto.h"
#include "textoogl.h"
#include <stdio.h>

#define BUFSTRING 256
#define NUMLINEASEVENTOS 8
/**
@author Turulo
*/
class Jugador: public Objeto{
public:
    Jugador();

    ~Jugador();
    void iniciar (int id,Casilla *casillas);
    void poner_nombre();
    bool analizando_resultado_dado(int tirada);
    bool puede_mover(int tirada);
    bool puede_tirar();
    bool tiene_todas_fichas_fuera();
    void TextoEventos_visualizar();
    void TextoEventos_insertar(char *textoevento, bool console=true);
    void TextoEventos_limpiar();
    bool hay_alguna_barrera();
    int id;
    Ficha fichas[4];
    int ultima_ficha_movida;
    int tipo_jugador; //0 humano, 1 bajo, 2 medio, 3 alto
    char nombre[BUFSTRING];
    char nombrecolor[BUFSTRING];
    char textoeventos[NUMLINEASEVENTOS][BUFSTRING];
    int numero_seises;
    bool ha_tirado;
    bool ha_movido;
    bool ha_comido;
    bool ha_llegado_a_final;
    bool puede_volver_a_tirar;
    bool a_casa_por_seises;
    bool cuenta20;
    bool activo;
    Casilla *casillas;
    int posicion_siguiente_texto;
    int numfichas;
};

#endif
