//
// C++ Implementation: menu
//
// Description: 
//
//
// Author: Turulo <turulomio@yahoo.es>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "menu.h"

Menu::Menu(SDL_Surface *screen){
  this->tipojugador[0]=0;
  this->tipojugador[1]=1;
  this->tipojugador[2]=2;
  this->tipojugador[3]=3;

  this->f=new Ficha[8];
  this->d=new Dado[2];
  for (int i=0;i<8;i++){
    this->f[i].iniciar(i);
  }

  this->pulsada_nueva_seleccion_jugadores=false;
  this->play_selected=false;
  this->menuactual=0;
  this->showcontroles=false;
  this->visible=true;
  this->salir=false;
  for (int i=0;i<NUMMENUITEMS;i++){
    mi[i].iniciar(i);
  }
  this->screen=screen;
  s=new Sound();
}


Menu::~Menu()
{
}




/*!
    \fn Menu::RenderScene()
 */
void Menu::RenderScene()
{    
    // Clear the window with current ing color
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  gluLookAt(10.5,10.5,40,10.5,10.5,0,0,1,0);   
  switch(this->menuactual){
    case 0: //GEDNERAL
      mi[0].dibujar();
      mi[1].dibujar();
      mi[2].dibujar();
      mi[7].dibujar();
      mi[20].dibujar();
      break;
    case 1: //OPCIONES
      mi[3].dibujar();
      mi[4].dibujar();
      mi[5].dibujar();
      mi[20].dibujar();
      break;
    case 2: //CONTROLES
      mi[6].dibujar();
      mi[19].dibujar();
      mi[20].dibujar();
      break;
    case 3: //CREDITOS
      mi[8].dibujar();
      mi[18].dibujar();
      mi[20].dibujar();
      break;
    case 4: //jugadores
      mi[9].dibujar(this->tipojugador[0]);
      mi[10].dibujar(this->tipojugador[1]);
      mi[11].dibujar(this->tipojugador[2]);
      mi[12].dibujar(this->tipojugador[3]);
      mi[13].dibujar();
      mi[14].dibujar();
      mi[15].dibujar();
      mi[16].dibujar();
      mi[17].dibujar();
      mi[20].dibujar();
      break;
  }



  for(int i=0;i<2;i++){
    //Dado
    this->d[i].dibujar(-5+i*31,-2,0,this->d->blanco, -.3);

    //Azul
    GLfloat pos[3]; pos[0]=-3+i*27;pos[1]=17;pos[2]=6;
    GLfloat escala[3]; escala[0]=3;escala[1]=3;escala[2]=1;
    this->f[i*4+0].setPosicion(pos);
    this->f[i*4+0].setColor(this->f[i].azul);
    this->f[i*4+0].dibujar(eMadera,escala, 1*pow(-1,i+1));
    //Roja
    pos[0]=-3+i*27;pos[1]=13;pos[2]=6;
    this->f[i*4+1].setPosicion(pos);
    this->f[i*4+1].setColor(this->f[i].rojo);
    this->f[i*4+1].dibujar(eMadera,escala, .75);
    //Amarilla
    pos[0]=-3+i*27;pos[1]=9;pos[2]=6;
    this->f[i*4+2].setPosicion(pos);
    this->f[i*4+2].setColor(this->f[i].amarillo);
    this->f[i*4+2].dibujar(eMadera,escala, .5);
    //Verde
    pos[0]=-3+i*27;pos[1]=5;pos[2]=6;
    this->f[i*4+3].setPosicion(pos);
    this->f[i*4+3].setColor(this->f[i].verde);
    this->f[i*4+3].dibujar(eMadera,escala, .25);
  }
}


/*!
    \fn Menu::ProcessObjeto(GLuint *pSelectBuff,int hits)
 */
void Menu::ProcessObjeto(GLuint *pSelectBuff,int hits)
{
  int id, count;
  char cMessage[64];
  count=pSelectBuff[0];

  if (hits==1){
    id=pSelectBuff[4];
//    printf("Hits %d Id %d\n",hits, id);
  switch(id){
    case 1://jugar
      s->play_sound("share/glparchis/play.wav");
      this->play_selected=true;
      this->visible=false;
      break;
    case 2://opciones
      this->menuactual=1;
      s->play_sound("share/glparchis/menu.wav");
      break;
    case 3://SALIR
      this->visible=false;
      this->salir=true;
      s->play_sound("share/glparchis/salida.wav");
      break;
    case 4://JUGADORES
      this->menuactual=4;
      s->play_sound("share/glparchis/menu.wav");
      break;
    case 5://CONTROLES
      this->menuactual=2;
      s->play_sound("share/glparchis/menu.wav");
      break;
    case 6://VOLVER
      this->menuactual=0;
      s->play_sound("share/glparchis/menu.wav");
      break;
    case 7://VOLVER de controles
      this->menuactual=1;
      s->play_sound("share/glparchis/menu.wav");
      break;
    case 8://CREDITOS
      this->menuactual=3;
      s->play_sound("share/glparchis/menu.wav");
      break;
    case 9://VOLVER DE CREDITOS
      this->menuactual=0;
      s->play_sound("share/glparchis/menu.wav");
      break;
    case 10://SELECTOR1
      this->cambiar_tipo_jugador(0);
      s->play_sound("share/glparchis/click.wav");
      break;
    case 11://SELECTOR2
      this->cambiar_tipo_jugador(1);
      s->play_sound("share/glparchis/click.wav");
      break;
    case 12://SELECTOR3
      this->cambiar_tipo_jugador(2);
      s->play_sound("share/glparchis/click.wav");
      break;
    case 13://SELECTOR4
      this->cambiar_tipo_jugador(3);
      s->play_sound("share/glparchis/click.wav");
      break;
    case 14://VOLVER DE JUGADORES
      this->pulsada_nueva_seleccion_jugadores=true;
      this->menuactual=1;
      s->play_sound("share/glparchis/menu.wav");
      break;
    default:
      s->play_sound("share/glparchis/clock.ogg");
      break;

  }
}
}


/*!
    \fn Menu::cambiar_tipo_jugador(int id_jugador)
 */
void Menu::cambiar_tipo_jugador(int id_jugador)
{
   if (this->tipojugador[id_jugador]==3){
     this->tipojugador[id_jugador]=-1;
   }else{
     this->tipojugador[id_jugador]++;
   }
}


/*!
    \fn Menu::EndRenderScene()
 */
void Menu::EndRenderScene()
{
  SDL_GL_SwapBuffers();
}
