//
// C++ Interface: modelo
//
// Description: 
//
//
// Author: Turulo <turulomio@yahoo.es>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef MODELO_H
#define MODELO_H
#define NUM_MODELS3DS 3
#define PATH3DS	/home/nobu/CVS/glparchis-20060201/src/3ds/
#define MAX_VERTICES 8000 // Max number of vertices (for each object)
#define MAX_POLYGONS 8000 // Max number of polygons (for each object)

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>

#include <GL/glut.h>

/**
@author Turulo
*/
class Modelo{
public:
    Modelo(GLuint *textures);

    ~Modelo();
typedef struct{
    float x,y,z;
}vertex_type;

// The polygon (triangle), 3 numbers that aim 3 vertices
typedef struct{
    int a,b,c;
}polygon_type;

// The mapcoord type, 2 texture coordinates for each vertex
typedef struct{
    float u,v;
}mapcoord_type;

// The object type
typedef struct {
	char name[20];
    
	int vertices_qty;
    int polygons_qty;

    vertex_type vertex[MAX_VERTICES]; 
    polygon_type polygon[MAX_POLYGONS];
    mapcoord_type mapcoord[MAX_VERTICES];
    int id_texture;
} obj_type, *obj_type_ptr;

   GLuint *textures;
   obj_type *models3ds;
    char Load3DS (obj_type_ptr ogg, char *filename);
    void dibujar_modelo_3ds(obj_type *, bool textura=true);
};

#endif
