/***************************************************************************
 *   Copyright (C) 2005 by MMM   *
 *   mamuma@eresmas.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "objeto.h"

Objeto::Objeto()
{
//Colores
  this->amarillo[0] = 1; this->amarillo[1]= 1; this->amarillo[2]= 0; this->amarillo[3]= 1;
  this->blanco[0] = 1; this->blanco[1]= 1; this->blanco[2]= 1; this->blanco[3]= 1;
  this->negro[0] = 0; this->negro[1]= 0; this->negro[2]= 0; this->negro[3]= 0;
  this->azul[0] = 0; this->azul[1]= 0; this->azul[2]= 1; this->azul[3]= 1;
  this->rojo[0] = 1; this->rojo[1]= 0; this->rojo[2]=0; this->rojo[3]= 1;
  this->verde[0] = 0; this->verde[1]= 1; this->verde[2]=0; this->verde[3]= 1;

//Material
  this->light_specular[0]=0; this->light_specular[1]=0; this->light_specular[2]=0; this->light_specular[3]=0;



}


Objeto::~Objeto()
{
}

void Objeto::copiar3(GLfloat array[3], GLfloat x, GLfloat y, GLfloat z)
{
  array[0]=x;
  array[1]=y;
  array[2]=z;
}

void Objeto::copiar4(GLfloat array[4],GLfloat x, GLfloat y, GLfloat z, GLfloat r)
{
  array[0]=x;
  array[1]=y;
  array[2]=z;
  array[3]=r;
}

void Objeto::setColor(GLfloat micolor[4])
{
  this->copiar4(this->color, micolor[0],micolor[1],micolor[2],micolor[3]);
}

void Objeto::setPosicion(GLfloat x, GLfloat y, GLfloat z)
{
  this->copiar3(this->posicion, x,y,z);
}


void Objeto::torre_triangular(){     
 glRotated(90,1,0,0);
 glBegin(GL_QUADS);
        GLTVector3 vPoints[20]={
          {0.0f, 0.0f, 0.0f},
          { 1.0f, 0.0f, 0.0f}, 
          { 0.5f, 1.0f, 0.0f}, 
          {0.0f, 0.0f, 0.0f}, 

     {0.0f, 0.0f, 0.0f},
     { 0.5f, 1.0f, 0.0f},
     {0.5f, 1.0f, 1.0f},
     { 0.0f, 0.0f, 1.0f},

          {0.0f, 0.0f, 1.0f}, 
          { 1.0f, 0.0f, 1.0f}, 
          { 0.5f, 1.0f, 1.0f}, 
          {1.0f, 0.0f, 1.0f},

     {1.0f, 0.0f, 1.0f},
     {0.5f, 1.0f, 1.0f},
     { 0.5f, 1.0f, 0.0f}, 
     { 1.0f, 0.0f, 0.0f},

     {1.0f, 0.0f, 0.0f}, 
     {1.0f, 0.0f, 1.0f}, 
     { 0.0f, 0.0f, 1.0f}, 
     { 0.0f, 0.0f, 0.0f}
        };
 
  GLTVector3 vNormal;
  gltGetNormalVector(vPoints[0],vPoints[1],vPoints[2],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[0]);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[1]);
  glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[2]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[3]);  
gltGetNormalVector(vPoints[4],vPoints[5],vPoints[6],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[4]);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[5]);
  glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[6]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[7]);  
gltGetNormalVector(vPoints[8],vPoints[9],vPoints[10],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[8]);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[9]);
  glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[10]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[11]);  
gltGetNormalVector(vPoints[12],vPoints[13],vPoints[14],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[12]);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[13]);
  glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[14]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[15]);  
gltGetNormalVector(vPoints[16],vPoints[17],vPoints[18],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[16]);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[17]);
  glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[18]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[19]); 
    glEnd();
}
void Objeto::cubo(){
      glBegin(GL_QUADS);
        GLTVector3 vPoints[24]={
          {0.0f, 0.0f, 0.0f}, 
          { 1.0f, 0.0f, 0.0f}, 
          { 1.0f, 0.0f, 1.0f}, 
          {0.0f, 0.0f, 1.0f}, 

     {0.0f, 0.0f, 1.0f},
     { 1.0f, 0.0f, 1.0f},
     { 1.0f, 1.0f, 1.0f},
     {0.0f, 1.0f, 1.0f},

     {0.0f, 0.0f, 0.0f},
     {0.0f, 1.0f, 0.0f},
     { 1.0f, 1.0f, 0.0f},
     { 1.0f, 0.0f, 0.0f}, 

     {0.0f, 1.0f, 0.0f}, 
     {0.0f, 1.0f, 1.0f}, 
     { 1.0f, 1.0f, 1.0f}, 
     { 1.0f, 1.0f, 0.0f}, 

     { 1.0f, 0.0f, 0.0f}, 
     { 1.0f, 1.0f, 0.0f}, 
     { 1.0f, 1.0f, 1.0f}, 
     { 1.0f, 0.0f, 1.0f}, 

          {0.0f, 0.0f, 1.0f}, 
          {0.0f, 1.0f, 1.0f}, 
          {0.0f, 1.0f, 0.0f},
          {0.0f, 0.0f, 0.0f}
        };
  GLTVector3 vNormal;
  gltGetNormalVector(vPoints[0],vPoints[1],vPoints[2],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[0]);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[1]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[2]);
  glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[3]);  
gltGetNormalVector(vPoints[4],vPoints[5],vPoints[6],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[4]);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[5]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[6]);
  glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[7]);  
gltGetNormalVector(vPoints[8],vPoints[9],vPoints[10],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[8]);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[9]);
  glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[10]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[11]);  gltGetNormalVector(vPoints[12],vPoints[13],vPoints[14],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[12]);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[13]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[14]);
  glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[15]);  gltGetNormalVector(vPoints[16],vPoints[17],vPoints[18],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[16]);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[17]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[18]);
  glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[19]);  gltGetNormalVector(vPoints[20],vPoints[21],vPoints[22],vNormal);
      glNormal3fv(vNormal);
      glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[20]);
      glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[21]);
      glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[22]);
      glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[23]);
    glEnd();
}

/*!
    Esta funcion debe tener antes una textura de un cubo desplegado con la cruz a la izquierda
 */
void Objeto::cubo_con_texturas(){
      float unter=1.0f/3.0f;
      float doster=2.0f/3.0f;
      glBegin(GL_QUADS);
        GLTVector3 vPoints[24]={
          {0.0f, 0.0f, 0.0f}, 
          { 1.0f, 0.0f, 0.0f}, 
          { 1.0f, 0.0f, 1.0f}, 
          {0.0f, 0.0f, 1.0f}, 

     {0.0f, 0.0f, 1.0f},
     { 1.0f, 0.0f, 1.0f},
     { 1.0f, 1.0f, 1.0f},
     {0.0f, 1.0f, 1.0f},

     {0.0f, 0.0f, 0.0f},
     {0.0f, 1.0f, 0.0f},
     { 1.0f, 1.0f, 0.0f},
     { 1.0f, 0.0f, 0.0f}, 

     {0.0f, 1.0f, 0.0f}, 
     {0.0f, 1.0f, 1.0f}, 
     { 1.0f, 1.0f, 1.0f}, 
     { 1.0f, 1.0f, 0.0f}, 

     { 1.0f, 0.0f, 0.0f}, 
     { 1.0f, 1.0f, 0.0f}, 
     { 1.0f, 1.0f, 1.0f}, 
     { 1.0f, 0.0f, 1.0f}, 

          {0.0f, 0.0f, 1.0f}, 
          {0.0f, 1.0f, 1.0f}, 
          {0.0f, 1.0f, 0.0f},
          {0.0f, 0.0f, 0.0f}
        };
  GLTVector3 vNormal;
  gltGetNormalVector(vPoints[0],vPoints[1],vPoints[2],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, unter);glVertex3fv(vPoints[0]);
  glTexCoord2f(0.25f, unter);glVertex3fv(vPoints[1]);
  glTexCoord2f(0.25f, doster);glVertex3fv(vPoints[2]);
  glTexCoord2f(0.0f, doster);glVertex3fv(vPoints[3]);  
gltGetNormalVector(vPoints[4],vPoints[5],vPoints[6],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.25f, doster);glVertex3fv(vPoints[4]);
  glTexCoord2f(0.5f, doster);glVertex3fv(vPoints[5]);
  glTexCoord2f(0.5f, 1.0f);glVertex3fv(vPoints[6]);
  glTexCoord2f(0.25f, 1.0f);glVertex3fv(vPoints[7]);  
gltGetNormalVector(vPoints[8],vPoints[9],vPoints[10],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.25f, doster);glVertex3fv(vPoints[8]);
  glTexCoord2f(0.5f, doster);glVertex3fv(vPoints[9]);
  glTexCoord2f(0.5f, unter);glVertex3fv(vPoints[10]);
  glTexCoord2f(0.25, unter);glVertex3fv(vPoints[11]);  gltGetNormalVector(vPoints[12],vPoints[13],vPoints[14],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.25f, 0.0f);glVertex3fv(vPoints[12]);
  glTexCoord2f(0.5f, 0.0f);glVertex3fv(vPoints[13]);
  glTexCoord2f(0.5f, unter);glVertex3fv(vPoints[14]);
  glTexCoord2f(0.25f, unter);glVertex3fv(vPoints[15]);  gltGetNormalVector(vPoints[16],vPoints[17],vPoints[18],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.5f, unter);glVertex3fv(vPoints[16]);
  glTexCoord2f(0.75f, unter);glVertex3fv(vPoints[17]);
  glTexCoord2f(0.75f, doster);glVertex3fv(vPoints[18]);
  glTexCoord2f(0.5f, doster);glVertex3fv(vPoints[19]);  gltGetNormalVector(vPoints[20],vPoints[21],vPoints[22],vNormal);
      glNormal3fv(vNormal);
      glTexCoord2f(0.75f, unter);glVertex3fv(vPoints[20]);
      glTexCoord2f(1.0f, unter);glVertex3fv(vPoints[21]);
      glTexCoord2f(1.0f, doster);glVertex3fv(vPoints[22]);
      glTexCoord2f(0.75f, doster);glVertex3fv(vPoints[23]);
    glEnd();
}


void Objeto::trapecio(){
      GLfloat x=4.0f/3.0f;
      GLfloat y=7.0f/3.0f;
      glBegin(GL_QUADS);
        GLTVector3 vPoints[24]={
          {0.0f, 0.0f, 0.0f}, 
          {y, 0.0f, 0.0f}, 
          { x, 1.0f, 0.0f}, 
          { 0.0f,1.0f, 0.0f}, 

     {0.0f, 1.0f, 0.0f},
     {0.0f, 0.0f, 0.0f},
     { 0.0f, 0.0f, 1.0f},
     { 0.0f, 1.0f, 1.0f},

     {0.0f, 1.0f, 1.0f},
     {0.0f, 0.0f, 1.0f},
     { y, 0.0f, 1.0f},
     { x, 1.0f, 1.0f}, 

     {x, 1.0f, 1.0f}, 
     {0.0f, 1.0f, 1.0f}, 
     { 0.0f, 1.0f, 0.0f}, 
     { x, 1.0f, 0.0f}, 

     { x, 1.0f, 0.0f}, 
     { x, 1.0f, 1.0f}, 
     { y, 0.0f, 1.0f}, 
     { y, 0.0f, 0.0f}, 

          {y, 0.0f, 0.0f}, 
          {y, 0.0f, 1.0f}, 
          {0.0f, 0.0f, 1.0f},
          {0.0f, 0.0f, 0.0f}
        };

  GLTVector3 vNormal;
  gltGetNormalVector(vPoints[0],vPoints[1],vPoints[2],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[0]);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[1]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[2]);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[3]);  
gltGetNormalVector(vPoints[4],vPoints[5],vPoints[6],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[4]);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[5]);
  glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[6]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[7]);  
gltGetNormalVector(vPoints[8],vPoints[9],vPoints[10],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[8]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[9]);
  glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[10]);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[11]);  gltGetNormalVector(vPoints[12],vPoints[13],vPoints[14],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[12]);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[13]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[14]);
  glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[15]);  gltGetNormalVector(vPoints[16],vPoints[17],vPoints[18],vNormal);
  glNormal3fv(vNormal);
  glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[16]);
  glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[17]);
  glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[18]);
  glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[19]);  gltGetNormalVector(vPoints[20],vPoints[21],vPoints[22],vNormal);
      glNormal3fv(vNormal);
      glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[20]);
      glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[21]);
      glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[22]);
      glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[23]);
    glEnd();
}



void Objeto::gltGetNormalVector(const GLTVector3 vP1, const GLTVector3 vP2, const GLTVector3 vP3, GLTVector3 vNormal)
    {
    GLTVector3 vV1, vV2;
    
    gltSubtractVectors(vP2, vP1, vV1);
    gltSubtractVectors(vP3, vP1, vV2);
    
    gltVectorCrossProduct(vV1, vV2, vNormal);
    gltNormalizeVector(vNormal);
    }


// Subtract one vector from another
void Objeto::gltSubtractVectors(const GLTVector3 vFirst, const GLTVector3 vSecond, GLTVector3 vResult) 
    {
    vResult[0] = vFirst[0] - vSecond[0];
    vResult[1] = vFirst[1] - vSecond[1];
    vResult[2] = vFirst[2] - vSecond[2];
    }
// Calculate the cross product of two vectors
void Objeto::gltVectorCrossProduct(const GLTVector3 vU, const GLTVector3 vV, GLTVector3 vResult)
	{
	vResult[0] = vU[1]*vV[2] - vV[1]*vU[2];
	vResult[1] = -vU[0]*vV[2] + vV[0]*vU[2];
	vResult[2] = vU[0]*vV[1] - vV[0]*vU[1];
	}
// Scales a vector by it's length - creates a unit vector
void Objeto::gltNormalizeVector(GLTVector3 vNormal)
    { 
    GLfloat fLength = 1.0f / gltGetVectorLength(vNormal);
    gltScaleVector(vNormal, fLength); 
    }

// Scales a vector by a scalar
void Objeto::gltScaleVector(GLTVector3 vVector, const GLfloat fScale)
    { 
    vVector[0] *= fScale; vVector[1] *= fScale; vVector[2] *= fScale; 
    }

// Gets the length of a vector squared
GLfloat Objeto::gltGetVectorLengthSqrd(const GLTVector3 vVector)
    { 
    return (vVector[0]*vVector[0]) + (vVector[1]*vVector[1]) + (vVector[2]*vVector[2]); 
    }
    
// Gets the length of a vector
GLfloat Objeto::gltGetVectorLength(const GLTVector3 vVector)
    { 
    return (GLfloat)sqrt(gltGetVectorLengthSqrd(vVector)); 
    }


/*!
    \fn Objeto::setTextura(int tipo)
 */
void Objeto::setTextures(GLuint *texturesoriginales)
{
   this->textures=texturesoriginales;
}



/*!
    \fn Objeto::plano()
 */
void Objeto::plano_texto()
{
  glBegin(GL_QUADS);
    GLTVector3 vPoints[4]={
          {0.0f, 0.0f, 0.0f}, 
          { 0.0f, 1.0f, 0.0f}, 
          { 1.0f, 1.0f, 0.0f}, 
          {1.0f, 0.0f, 0.0f}
        };
    GLTVector3 vNormal;
    gltGetNormalVector(vPoints[0],vPoints[1],vPoints[2],vNormal);
    glNormal3fv(vNormal);
    glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[0]);
    glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[1]);
    glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[2]);
    glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[3]);  
  glEnd();
}


/*!
    \fn Objeto::plano()
 */
void Objeto::plano()
{ 
    glBegin(GL_QUADS);
    GLTVector3 vPoints[4]={
          {0.0f, 0.0f, 0.0f}, 
          { 0.0f, 1.0f, 0.0f}, 
          { 1.0f, 1.0f, 0.0f}, 
          {1.0f, 0.0f, 0.0f}
        };
    GLTVector3 vNormal;
    gltGetNormalVector(vPoints[0],vPoints[1],vPoints[2],vNormal);
    glNormal3fv(vNormal);
    glTexCoord2f(0.0f, 0.0f);glVertex3fv(vPoints[0]);
    glTexCoord2f(0.0f, 1.0f);glVertex3fv(vPoints[1]);
    glTexCoord2f(1.0f, 1.0f);glVertex3fv(vPoints[2]);
    glTexCoord2f(1.0f, 0.0f);glVertex3fv(vPoints[3]);  
  glEnd();
}
