/***************************************************************************
 *   Copyright (C) 2005 by MMM                                             *
 *   mamuma@eresmas.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

// #include "globals.h"
#include "partida.h"

Partida::Partida()
{/*
  this->testeo=new Testeo();
  testeo->inicializarFichasEnCasillas();*/

  this->estado_eventos=-1;
  this->salir=false;
  this->vista=1;
  this->numero_cambios_jugador=0;
  this->rot=0.1;
  this->t=new Textura();
  this->showcontroles=false;
  this->m=new Modelo(this->t->textures);
  this->dado=new Dado();
  this->dado->setTextures(t->textures);
  this->identificadorjugador= new IdentificadorJugador();
  this->tablero=new Tablero(1);
  this->jugador_actual=0;
  this->numero_jugadores=4;
  this->visible=true;
  this->ia=new IA();

  for (int i=0; i<this->tablero->numcasillas;i++){
    this->casillas[i].inicializar(i,this->t->textures);
  }

  for (int i=0;i<4; i++){
    jugadores[i].iniciar(i,this->casillas);
    for (int j=0;j<4;j++){
      int casillaficha=jugadores[i].fichas[j].ruta[0];
      jugadores[i].fichas[j].setPosicion(casillas[casillaficha].getNuevaPosicion(jugadores[i].fichas[j].posicion_en_casilla_inicial,jugadores[i].fichas[j].posicion_en_casilla));
    }
  }

  this->jugador_actual=&this->jugadores[0];
  s=new Sound();
}

Partida::~Partida()
{
}




/*!
    \fn Partida::siguiente_jugador()
 */
void Partida::siguiente_jugador()
{
   //Ha finalizado
   if (this->ha_finalizado())
   {
     this->estado_eventos=3;
     return;
   }

   //DESMARCADO
    for (int i=0;i<4;i++){
       this->jugador_actual->fichas[i].puedemover=false;
    }

//   printf ("El jugador %d que acaba turno tiene el tipo %d\n",this->jugador_actual->id,this->jugador_actual->tipo_jugador);
  char cadena[100];
  char saveturn[100];

  this->numero_cambios_jugador++;
  //Graba fichero depuracion
//   if (this->jugador_actual->id==0)

  //Imprime fin de turno del anterior
  if(this->jugador_actual->activo==true){
/*    
    xml_glParchis *xml=new xml_glParchis();
    vprintf(saveturn,"/tmp/glparchis.%d",this->numero_cambios_jugador);
    xml->save(saveturn);*/
    printf(gettext("%s: Fin de turno\n"),this->jugador_actual->nombrecolor);
    this->jugador_actual->TextoEventos_insertar(gettext("Fin de turno\n"),false);
  }

  //Cambia de jugador
  if (this->jugador_actual->id==this->numero_jugadores-1){
    this->jugador_actual=&this->jugadores[0];
  }else{
    int idnuevo=this->jugador_actual->id+1;
    this->jugador_actual=&this->jugadores[idnuevo];
  }

  //Si el jugador est�inactivo pasa de �
  if (this->jugador_actual->activo==false){  
    //printf("Pasando del jugador %d por estar inactivo\n", this->jugador_actual->id);
    this->siguiente_jugador();
    return;
  }

  //Sigue cambiando de jugador
//   this->jugador_actual->ha_movido=false;
//   this->jugador_actual->ha_tirado=false;

  //Imprime el Inicio de turno del nuevo jugador
  this->jugador_actual->TextoEventos_limpiar();
  printf("%s: Inicio de Turno %d\n",this->jugador_actual->nombrecolor,this->numero_cambios_jugador);
  this->jugador_actual->TextoEventos_insertar("Inicio de turno\n",false);

  this->estado_eventos=1;


  this->identificadorjugador->setTextura(eTirarDado);
  if (this->jugador_actual->tipo_jugador>0){
    this->ia_emulate_dado();
  }
}



/*!
    \fn Partida::ha_finalizado
 */
bool Partida::ha_finalizado()
{
  for (int i=0;i<4; i++){
    bool jugador_acabado=true;
    for (int j=0;j<4;j++){
      if (jugadores[i].fichas[j].posicion_ruta!=72)
        jugador_acabado=false;
    }
    if (jugador_acabado==true){
      printf("*** El jugador %s (%d) ha ganado la partida\n",this->jugador_actual->nombrecolor, this->jugador_actual->id);

        s->play_sound("share/glparchis/win.ogg");
      return true;
    }
  }
  return false;
}



/*!
    \fn Partida::after_clicking_dado()
    Esta funci� debe     
 */
void Partida::after_clicking_dado()
{
  //Tira dado
  this->tirando_dado();
//   printf("%s: Empezando after clicking dado\n", this->jugador_actual->nombrecolor);
   
  int idfichafama=this->alguna_ficha_forzada_a_mover_automaticamente();
  if(idfichafama!=-1){
     JugFicha j; j.jugador=this->jugador_actual->id; j.ficha=idfichafama;
     this->estado_eventos=2; //Permite pulsar ficha
     this->after_clicking_any_ficha(j);
     return;
  }

  if(this->alguna_ficha_forzada_a_mover()){
     this->identificadorjugador->setTextura(eMoverFicha);
     this->estado_eventos=2; //Permite pulsar ficha
     if (this->jugador_actual->tipo_jugador>0){
       this->ia_emulate_ficha();
     }
     return;
  }


  if(this->alguna_puede_mover()){
     this->identificadorjugador->setTextura(eMoverFicha);
     this->estado_eventos=2; //Permite pulsar ficha
     if (this->jugador_actual->tipo_jugador>0){
       this->ia_emulate_ficha();
     }
  }else{
     if (puede_tirar_otra_vez()){
       this->estado_eventos=1; //Permite pulsar dado
       this->identificadorjugador->setTextura(eTirarDado);
       if (this->jugador_actual->tipo_jugador>0){
         this->ia_emulate_dado();
       }
     }else{
       this->siguiente_jugador();	
     }
  }

/*

      if (this->jugador_actual->ha_tirado==false)
      {

        int tirada=this->dado->tirar(this->jugador_actual->tiene_todas_fichas_fuera(),this->jugador_actual->id);

        char tmp[1000];
        sprintf(tmp,"Ha sacado un %d.\n",this->dado->tirada);
        printf("%s: He sacado un %d.\n",this->jugador_actual->nombrecolor, this->dado->tirada);
        this->jugador_actual->TextoEventos_insertar(tmp, false);

        this->jugador_actual->ha_tirado=true;
        this->jugador_actual->analizando_resultado_dado(this->dado->tirada);
        if (this->jugador_actual->tipo_jugador==0 ){
		     s->play_sound("share/glparchis/dado.wav");
        }
        this->before_clicking_any_ficha();

      }
      else
      {
          this->jugador_actual->TextoEventos_insertar("Seleccione una ficha\n",false);
          //printf("Ha pulsado el dado y debe seleccionar una ficha\n");
          if (this->jugador_actual->tipo_jugador==0 ){
	   	    s->play_sound("share/glparchis/clock.ogg");
          }
      }*/
}


/*!
    \fn Partida::after_clicking_any_ficha()
 */
void  Partida::after_clicking_any_ficha(JugFicha jugfic){

   printf ("Pasando por after_clicking any_ficha\n");

    if (this->dado->tirada==7)
      this->identificadorjugador->setTextura(eMoverFicha7);
    else if(this->dado->tirada==20)
      this->identificadorjugador->setTextura(eMoverFicha20);
    else
      this->identificadorjugador->setTextura(eMoverFicha);



  this->ficha_sel=&this->jugadores[jugfic.jugador].fichas[jugfic.ficha];


  if (this->come() || this->llega_a_casa()){
    if (mueve()==false) return;
    if(this->alguna_puede_mover()){
     this->estado_eventos=2; //Permite pulsar ficha
     if (this->jugador_actual->tipo_jugador>0){
       this->ia_emulate_ficha();
     }
    }else{
       if (puede_tirar_otra_vez()){
         this->estado_eventos=1; //Permite pulsar dado       
         this->identificadorjugador->setTextura(eTirarDado);
         if (this->jugador_actual->tipo_jugador>0){
            this->ia_emulate_dado();
         }
       }else{
         this->siguiente_jugador();	
       }
    }
  }else{
    if (mueve()==false) return;
     if (puede_tirar_otra_vez()){
       this->estado_eventos=1; //Permite pulsar dado
         this->identificadorjugador->setTextura(eTirarDado);
         if (this->jugador_actual->tipo_jugador>0){
            this->ia_emulate_dado();
         }
     }else{
       this->siguiente_jugador();	
     }
  }
// 
//       this->ficha_sel=&this->jugadores[jugfic.jugador].fichas[jugfic.ficha];
// 
//   if (this->jugador_actual->tipo_jugador==0){
//       if (this->ficha_sel->id_jugador==this->jugador_actual->id){
// //           printf ("El tipo del jugador actual es %d y el id es %d\n", this->jugador_actual->tipo_jugador, this->jugador_actual->id);
//           if (this->ficha_sel->puede_mover(this->dado->tirada)){
//               s->play_sound("share/glparchis/click.wav");
//           }else{
//               s->play_sound("share/glparchis/clock.ogg");
//           }
//       }else{
//           s->play_sound("share/glparchis/clock.ogg");
//       }
//   }
//   //Comprobaciones antes de mover
//   if (this->before_moving_ficha(jugfic)==false)
//      printf ("Me he quedado aquí\n");
//      return;
//   //Si ha tirado pero no ha movido
//   if (this->jugador_actual->ha_movido==false)
//   {
//     if (this->ficha_sel->mover(this->dado->tirada)==false)
//        return;
//     //Comprobaciones despues de mover
//     this->after_moving_ficha(jugfic);
//   }else{
//     this->siguiente_jugador();
//   }
//   

}


/*!
    \fn Partida::after_moving_ficha()
 */
// void Partida::after_moving_ficha(JugFicha jugfic)
// {
// 
// 
//   if (this->ha_finalizado()){
//     this->jugador_actual->TextoEventos_insertar("HE GANADO LA PARTIDA\n");
//     return;
//   }
// 
// //   this->jugador_actual->ultima_ficha_movida=this->ficha_sel->id;
//   this->jugador_actual->ha_movido=true;
// 
//    //Comprueba si se ha creado barrera.
//    if (this->hay_ficha_mismo_jugador(this->ficha_sel->id_casilla(), this->jugador_actual->id)==true){
//      this->casillas[this->ficha_sel->id_casilla()].tiene_barrera=true;
//    }else{
//      this->casillas[this->ficha_sel->id_casilla()].tiene_barrera=false;
//    }
// 
//    //Comprueba si la ha metido en la casilla final y cuenta 10
//   if(this->ficha_sel->posicion_ruta==72 && this->jugador_actual->puede_mover(10)){//Casilla final
//     printf("Ha metido una ficha en la casilla final y puede contar 10\n");
//     this->dado->tirada=10;
//     this->jugador_actual->ha_tirado=true;
//     this->jugador_actual->ha_movido=false;
//       this->identificadorjugador->setTextura(eMoverFicha10);
//     return;
//   }
// 
// 
//   //Si ha tirado y puede volver a tirar
//   if (this->jugador_actual->puede_volver_a_tirar==true){
//     this->jugador_actual->ha_tirado=false;
//     this->jugador_actual->ha_movido=false;
//     this->jugador_actual->puede_volver_a_tirar=false;
//     this->identificadorjugador->setTextura(eVolverATirar);  
// 
// 
//   
//   }else{
//     this->siguiente_jugador();
//   }
// 
// 
// 
// }
// 

/*!
    \fn Partida::before_moving_ficha(int idFicha)
 */
// bool Partida::before_moving_ficha(JugFicha jugfic)
// {
//    //Devuelve false si no hay que moverla por las comprobaciones que se hacen
//   //Si selecciona una ficha que no le corresponde
//   if (this->jugador_actual->id!=this->ficha_sel->id_jugador){
//     return false;
//   }
// 
// 
//   //Si no ha tirado no puede mover
//   if (this->jugador_actual->ha_tirado==false){
// //     printf ("El jugador no ha tirado\n");
//     this->activar_IA();
//     return false;
//   }
// /*
//   //An siendo un 5 no se puede mover si hay dos fichas del mismo color
//   // en la casilla inicial.
//    if (this->posicion_ruta==0 && tirada==5 && this->casillas[this->ruta[1]].numfichas==2){
//      printf ("El jugador %d no puede sacar una ficha a la casilla inicial por estar ocupada\n", this->id_jugador);
//      return false;
//    } 
// */
// 
// 
//   //Aqu�se pone todo el tema de comida de ficha
//   if (this->come_si_puede()==true){
//      //Si ha comido cuenta 20 pero puede no poder mover.
//      this->before_clicking_any_ficha();
//      return false;//Por que lo hace todo la funci�
//   }
// 
//   //Obliga a romper una barrera
//   if (this->dado->tirada==6 || this->dado->tirada==7){
//     if (this->jugador_actual->hay_alguna_barrera()==true){
// //        if(this->ficha_sel->esta_en_barrera()==false){
//        if(this->casilla_tiene_barrera(this->ficha_sel->ruta[this->ficha_sel->posicion_ruta])==-1){
//          this->jugador_actual->TextoEventos_insertar("Rompe la barrera\n");
//          return false;
//        }
//     }
//   }
//   printf("%s: Puedo mover una ficha\n",this->jugador_actual->nombrecolor);
//   return true;
// }


/*!
    \fn Partida::before_clicking_any_ficha()
 */
// void Partida::before_clicking_any_ficha()
// {
//   //Una vez tirado el dado y antes de pulsar una tecla se debe:
//   //Comprueba si puede mover y le deja hacerlo
//   if(this->jugador_actual->puede_mover(this->dado->tirada)==true){
//     if (this->dado->tirada==7)
//       this->identificadorjugador->setTextura(eMoverFicha7);
//     else if(this->dado->tirada==10)
//       this->identificadorjugador->setTextura(eMoverFicha10);
//     else if(this->dado->tirada==20)
//       this->identificadorjugador->setTextura(eMoverFicha20);
//     else
//       this->identificadorjugador->setTextura(eMoverFicha);
//     //Manda a casa si han salido 3 seises.Esto es antes de 
//     //hacer click en la ficha ya que se va la que se movio 
//     //el 6 por ltima vez
//     if (this->jugador_actual->a_casa_por_seises==true){
// // // //       this->jugador_actual->fichas[this->jugador_actual->ultima_ficha_movida].mover_posicion_ruta(0);
//       this->jugador_actual->a_casa_por_seises==false;/*
//       this->after_moving_ficha(this->jugador_actual->ultima_ficha_movida);*/
//       JugFicha ultimo;
//       this->after_moving_ficha(ultimo);
//       this->siguiente_jugador();
//     }
//     return;
//   }else{
//   //Este es el caso en que no puede mover una ficha y salen 3 seises
//      if (this->jugador_actual->a_casa_por_seises==true){
//        this->jugador_actual->a_casa_por_seises=false;
//        printf("Ha salido 3 seises pero como no puede mover no pasa nada\n");
//        this->siguiente_jugador();
//        return;
//     }
//     char tmp[1000];
//     sprintf(tmp,"No puede mover %d.\n",this->dado->tirada);
//     printf("%s: No puede mover la tirada de %d\n",this->jugador_actual->nombrecolor, this->dado->tirada);
//     this->jugador_actual->TextoEventos_insertar(tmp, false);
//   }
// 
//   //En caso de que no pueda mover comprueba si puede volver a tirar y le
//  // deja hacerlo.
//   if(this->jugador_actual->puede_volver_a_tirar==true){
//     this->identificadorjugador->setTextura(eVolverATirar);
//     this->jugador_actual->ha_tirado=false;
//     this->jugador_actual->ha_movido=false;
//     this->jugador_actual->puede_volver_a_tirar=false;
// //     //Aquí se paraba 
// //     if (this->jugador_actual->tipo_jugador>0){
// //       activar_IA();
// //     }
//     printf ("Se para aquí\n");
//     return;
//   }
// 
// 
//   //En caso contrario deber�cambiarse de jugador
//   this->siguiente_jugador();
// }
// 

/*!
    \fn Partida::activar_IA()
 */
// void Partida::activar_IA(bool humanos)
// {
//   if (this->jugador_actual->tipo_jugador>0|| humanos==true){//Humano
//     int myhits;
//     GLuint mydado[15];
//     mydado[4]=17;
//     myhits=1;
//     if(this->jugador_actual->ha_tirado==false || this->jugador_actual->puede_volver_a_tirar==true)
//        ProcessObjeto(mydado,myhits,false);
//     if(this->jugador_actual->ha_movido==false){
//       for (int i=0;i<4;i++){
//          JugFicha j; j.jugador=this->jugador_actual->id; j.ficha=i;
//          if (this->jugador_actual->fichas[i].puede_mover(this->dado->tirada)&& this->before_moving_ficha(j)){
//             this->after_clicking_any_ficha(j);
//             printf("Voy por aquí 1243\n");
// //             return;
//          }
//        }
//     }
//   }
// }

void Partida::ProcessObjeto(GLuint *pSelectBuff,int hits,bool rightmousebutton){
  int id, count;
  char cMessage[64];
  count=pSelectBuff[0];
//   printf("Estado eventos: %d\n", this->estado_eventos);
//      printf("Hay %d, %d , %d , %d || %d %d %d %d en buffer\n" ,pSelectBuff[0],pSelectBuff[1],pSelectBuff[2],pSelectBuff[3],pSelectBuff[11],pSelectBuff[12],pSelectBuff[13],pSelectBuff[14]);
  if (rightmousebutton==false){
//          printf("Hits %d Id %d\n",hits, id);
    if (this->estado_eventos==1){
      if (hits==1){
        id=pSelectBuff[4];
        switch(id){
          case 17://dado
             this->after_clicking_dado();
             return;
             break;
        }
      }
    }else if (this->estado_eventos==2){ 
//        printf("Running estado 2\n");
       if (hits==3){
         id=pSelectBuff[14];
         if (id>=1 && id <=16){
             this->after_clicking_any_ficha(this->idprocess2JugFicha(id));
         } 
      }
      return;
    }
  } else { //right button true.
     if (hits==2){
      id=pSelectBuff[9];
      this->show_ids_ficha(id);
     }
     if (hits==3){
      id=pSelectBuff[14];
      this->show_ids_ficha(id);
    }
  }
}



/*!
    \fn Partida::RenderScene()
 */
void Partida::RenderScene()
{
    // Clear the window with current ing color
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	  switch (vista){
	  case 1:
	    gluLookAt(10.5,12,36,10.5,12,0,0,1,0);
	    break;
	  case 9:
// 	    gluLookAt(10.5,-25,3,10.5,3,0,0,0,1);
	    break;
	  case 2:
	    gluLookAt(10.5,-7,35,10.5,9,0,0,0,1);
	    break;
	  case 10:
// 	    rot=rot+0.01;
// 	    gluLookAt(10.5,10.5,30,rot,rot,10,rot,0,0);
	    break;
	  case 11:
// 	    rot=rot-0.01;
// 	    gluLookAt(-15,10,rot,rot,rot,0,15,0,0);
	    break;
	  case 4:
	    gluLookAt(10.5,10.5,-50,10.5,10.5,0,0,-1,0);
	    break;
	  case 3:
	    gluLookAt(10.5,10.5,50,10.5,10.5,0,0,1,0);
	    break;

	  case 5:
	    gluLookAt(-4,-4,25,10.5,10.5,0,1,1,0);
	    break;
	  case 6:
	    gluLookAt(29,-4,25,10.5,10.5,0,-1,1,0);
	    break;
	  case 7:
	    gluLookAt(29,29,25,10.5,10.5,0,-1,-1,0);
	    break;
	  case 8:
	    gluLookAt(-4,29,25,10.5,10.5,0,1,-1,0);
	    break;
	  }



    if (this->jugadores[0].tipo_jugador==0){
      this->casillas[101].texturaactual=eCasillaInicioHuman;
    }    
    if (this->jugadores[0].activo==false){
      this->casillas[101].texturaactual=eCasillaInicioSinUsuario;
    }

    if (this->jugadores[3].tipo_jugador==0){
      this->casillas[100].texturaactual=eCasillaInicioHuman;
    }
    if (this->jugadores[3].activo==false){
      this->casillas[100].texturaactual=eCasillaInicioSinUsuario;
    }

    if (this->jugadores[2].tipo_jugador==0){
      this->casillas[103].texturaactual=eCasillaInicioHuman;
    }   
    if (this->jugadores[2].activo==false){
      this->casillas[103].texturaactual=eCasillaInicioSinUsuario;
    }

    if (this->jugadores[1].tipo_jugador==0){
      this->casillas[102].texturaactual=eCasillaInicioHuman;
    }    
    if (this->jugadores[1].activo==false){
      this->casillas[102].texturaactual=eCasillaInicioSinUsuario;
    }

    this->jugadores[0].TextoEventos_visualizar();
    this->jugadores[1].TextoEventos_visualizar();
    this->jugadores[2].TextoEventos_visualizar();
    this->jugadores[3].TextoEventos_visualizar();

   this->tablero->dibujar(-2,-2,-1,this->tablero->blanco, this->t->madera()  );
   this->identificadorjugador->dibujar(0,24,-1,this->jugador_actual->color);
 
  for (int i=0; i<this->tablero->numcasillas;i++){
    this->casillas[i].dibujar();
  }

  for (int i=0; i<4;i++){
    for (int j=0; j<4;j++){
      this->jugadores[i].fichas[j].dibujar(eMadera);
    }
  }


   this->dado->dibujar(26,12,2,this->dado->color);

//    testeo->FichasEnCasillas();



}


void Partida::KeyPressFunc(unsigned char key, int x, int y){
//   printf("F1 %d\n",key);
  switch(key){      
    case 13://Enter
        if (this->estado_eventos==1){
           ia_emulate_dado();
        }else{
           ia_emulate_ficha();
        }
        break;
    case 27://Escape        
        s->play_sound("share/glparchis/salida.wav");
        this->salir=true;
        break;
    case 32://Space
        s->play_sound("share/glparchis/play.wav");
        vista++;
        if(vista > 8)
           vista = 1;
        break;
  }
}


/*!
    \fn Partida::EndRenderEscene()
 */
void Partida::EndRenderScene()
{
  SDL_GL_SwapBuffers();
}




/*!
    \fn Partida::jugadores_fichas_en_casilla(int idCasilla)
 */
int * Partida::jugadores_fichas_en_casilla(int idCasilla)
{
  int salida[2];
  salida[0]=-1;
  salida[1]=-1;

if (this->casillas[idCasilla].numfichas>=1 ){
  for (int i=0;i<4; i++){
    for (int j=0;j<4;j++){
      if (idCasilla==jugadores[i].fichas[j].id_casilla() && this->jugador_actual->id!=i){
        salida[0]=i;
        salida[1]=j;
        printf("Hay una ficha (%d,%d) de otro jugador en la casilla\n",i, j);
        return salida;
      }
    }
  }
}
  printf("%s: No hay una ficha de otro jugador en la casilla %d\n",this->jugador_actual->nombrecolor,idCasilla);
  return salida;
}







/*!
    \fn Partida::hay_ficha_mismo_jugador(int id_casilla)
 */
bool Partida::hay_ficha_mismo_jugador(int id_casilla, int id_jugador_recien_movido)
{
if (this->casillas[id_casilla].numfichas==2 ){
  int numfichas_encasilla=0;
  for (int i=0;i<4; i++){
    if (id_casilla==jugadores[id_jugador_recien_movido].fichas[i].id_casilla() && this->jugador_actual->id==id_jugador_recien_movido){
      numfichas_encasilla++;
    }
  }

  if (numfichas_encasilla>=2){
    printf("Hay una ficha del mismo jugador en la casilla %d\n", id_casilla);
    return true;
  }else{
    return false;
  }
}
}


/*!
    \fn Partida::show_ids_ficha(int id)
 */
void Partida::show_ids_ficha(int id)
{
  if (id<1000){
    JugFicha j;
    j=this->idprocess2JugFicha(id);
    printf ("Jugador: %d. Ficha:%d. Puede mover:%d. Posicion Casilla:%d.\n",j.jugador, j.ficha, this->jugadores[j.jugador].fichas[j.ficha].puedemover,this->jugadores[j.jugador].fichas[j.ficha].posicion_en_casilla );
  } else {
    printf ("Casilla:%d. Num Fichas:%d. Casilla segura: %d\n",id-1000,this->casillas[id-1000].numfichas, this->es_casilla_segura(id-1000));
  }
}




/*!
    \fn Partida::idprocess2JugFic(int idProcess)
 */
JugFicha Partida::idprocess2JugFicha(int idProcess)
{
  JugFicha r;

  switch(idProcess){
    case 1:
      r.jugador=0;
      r.ficha=0;
      break;
    case 2:
      r.jugador=0;
      r.ficha=1;
      break;
    case 3:
      r.jugador=0;
      r.ficha=2;
      break;
    case 4:
      r.jugador=0;
      r.ficha=3;
      break;
    case 5:
      r.jugador=1;
      r.ficha=0;
      break;
    case 6:
      r.jugador=1;
      r.ficha=1;
      break;
    case 7:
      r.jugador=1;
      r.ficha=2;
      break;
    case 8:
      r.jugador=1;
      r.ficha=3;
      break;
    case 9:
      r.jugador=2;
      r.ficha=0;
      break;
    case 10:
      r.jugador=2;
      r.ficha=1;
      break;
    case 11:
      r.jugador=2;
      r.ficha=2;
      break;
    case 12:
      r.jugador=2;
      r.ficha=3;
      break;
    case 13:
      r.jugador=3;
      r.ficha=0;
      break;
    case 14:
      r.jugador=3;
      r.ficha=1;
      break;
    case 15:
      r.jugador=3;
      r.ficha=2;
      break;
    case 16:
      r.jugador=3;
      r.ficha=3;
      break;
    default:
      printf("Error en la funcion idprocess2jugfichas\n");
      this->salir=true;
      break;
  }
  return r;
}


/*!
    \fn Partida::casilla_tiene_barrera(int idcasilla)
    Funcion que devuelve -1 si no tiene barrera
    y un entero que coincide con el id_jugador del color de la barrera
    en caso de que la tenga.
 */
int Partida::casilla_tiene_barrera(int idcasilla)
{
  // Num fichas en casilla debe ser 2
  if (this->casillas[idcasilla].numfichas<2){
    return -1;
  }

    //No puede ser ni la primera casilla ni la última
    //Da igual la ficha que sea es para comprobar la ruta
  for (int i=0;i<this->numero_jugadores;i++){
    int num_casillas_ruta=this->jugadores[i].fichas[0].num_casillas_ruta;

    // Las 2 fichas sean del mismo color
    int contador_casillas_mismo_color=0;
    for (int j=0;j<4;j++){

      //Si estan en la casilla de inicio o final salta a la siguiente
      if (this->jugadores[i].fichas[j].ruta[0]==idcasilla || this->jugadores[i].fichas[j].ruta[num_casillas_ruta-1]==idcasilla){
         printf("Ficha en inicio o final\n");
         continue;
      }
      //Comprueba por jugador que tengan el mismo color.
      int posicion_ruta=this->jugadores[i].fichas[j].posicion_ruta;
      if (this->jugadores[i].fichas[j].ruta[posicion_ruta]==idcasilla){
         contador_casillas_mismo_color++;
      }
    }
    if (contador_casillas_mismo_color==2){
       printf("%s: Hay una barrera en la casilla %d del color %s\n",this->jugador_actual->nombrecolor, idcasilla, this->jugadores[i].nombrecolor);
       return i;
    }
  }
  return -1;
}


/*!
    \fn Partida::alguna_puede_mover()
 */
bool Partida::alguna_puede_mover()
{
    bool resultado=false;
    JugFicha j;
    //Desmarcado y marcado de si las fichas pueden mover
    for (int i=0;i<4;i++){
       j.jugador=this->jugador_actual->id;
       j.ficha=i;
       this->jugador_actual->fichas[i].puedemover=false;
       this->jugador_actual->fichas[i].puedemover=this->puede_mover(j);
       if (this->jugador_actual->fichas[i].puedemover==true){
          resultado=true;
       }
    }
    return resultado;
}


/*!
    \fn Partida::puede_mover(JugFicha j)
 */
bool Partida::puede_mover(JugFicha j)
{
  //Se pone como true y si falla algn caso se devuelve false en ese s�
  //No se puede mover de la casilla inicial si no es un 5
  if (this->jugadores[j.jugador].fichas[j.ficha].posicion_ruta==0 && this->dado->tirada!=5)
    return false; 

  //No se puede mover si llega al final
  if (this->jugadores[j.jugador].fichas[j.ficha].posicion_ruta+this->dado->tirada>72)
    return false; 

  //No se puede mover si el sitio a donde va est�ocupado
    if(this->casillas[this->jugadores[j.jugador].fichas[j.ficha].ruta[this->jugadores[j.jugador].fichas[j.ficha].posicion_ruta+this->dado->tirada]].numfichas==2){
      if (this->jugadores[j.jugador].fichas[j.ficha].posicion_ruta+this->dado->tirada>0 && this->jugadores[j.jugador].fichas[j.ficha].posicion_ruta+this->dado->tirada<72){ //La casilla incial y final tienen 4
        printf("No puede mover por estar ocupada la casilla\n");
        return false;
      }
    }

  //No se puede mover si hay barrera por medio
  for (int i=1; i<=this->dado->tirada;i++){
    if(this->casilla_tiene_barrera(this->jugadores[j.jugador].fichas[j.ficha].ruta[this->jugadores[j.jugador].fichas[j.ficha].posicion_ruta+i])>-1) {
          printf("No puede mover por haber una barrera\n");
          return false;
    }
  }

  return true;
}


/*!
    \fn Partida::puede_tirar_otra_vez()
 */
bool Partida::puede_tirar_otra_vez()
{

  if (this->jugador_actual->a_casa_por_seises){
    this->jugador_actual->a_casa_por_seises=false;
    return false;
  }

  if(this->dado->tirada==6 || this->dado->tirada==7){
    return true;
  }

  return false;
}


/*!
    \fn Partida::alguna_ficha_forzada_a_mover()
 */
bool Partida::alguna_ficha_forzada_a_mover()
{
    //Fuerza a salir si teiene barrera
    if (this->jugador_actual->hay_alguna_barrera() ){
       //Como no se sabe donde esta la barrera recorre todas las fichas preguntando
       bool forzadaamover=false;
       JugFicha j;
       for (int i=0;i<4;i++){
          j.jugador=this->jugador_actual->id;
          j.ficha=i;
          if (this->casilla_tiene_barrera( this->jugador_actual->fichas[i].ruta[this->jugador_actual->fichas[i].posicion_ruta])==this->jugador_actual->id  && this->puede_mover(j)){
             if(this->dado->tirada==6 || this->dado->tirada==7){
               this->jugador_actual->fichas[i].puedemover=true;
               printf("Hay una ficha forzada a mover\n");
               forzadaamover=true;
             }
          }
       }
       return forzadaamover;
    }
  return false;
}


/*!
    \fn Partida::alguna_ficha_forzada_a_mover()
 */
int Partida::alguna_ficha_forzada_a_mover_automaticamente()
{
    JugFicha j;
    j.jugador=this->jugador_actual->id;
    j.ficha=this->jugador_actual->ultima_ficha_movida;
    //Manda a casa si han salido 3 seises.
    if (this->jugador_actual->a_casa_por_seises==true && this->puede_mover(j)){
       this->jugador_actual->fichas[this->jugador_actual->ultima_ficha_movida].puedemover=true;
       printf("Hay una ficha forzada a mover automaticamente\n");
       this->jugador_actual->fichas[this->jugador_actual->ultima_ficha_movida].casillasamoverautomaticamente=-this->jugador_actual->fichas[this->jugador_actual->ultima_ficha_movida].posicion_ruta;
       return this->jugador_actual->ultima_ficha_movida;
    }
    return -1;
}


/*!
    \fn Partida::come()
 */
bool Partida::come()
{
  //Porque sino comería en la posicioN_ruta5;
  int tirada=this->dado->tirada;
  if (this->ficha_sel->posicion_ruta==0 && this->dado->tirada==5){
    tirada=1;
  }

  //Comprueba si la casilla donde se come es segura
  int posicionrutacomida=this->ficha_sel->posicion_ruta+tirada;
  if (this->es_casilla_segura(this->ficha_sel->ruta[posicionrutacomida])==true){
    return false;
  }

  //Comprueba si hay otra ficha y en caso positivo si es de otro color al suyo
  int *arr=this->jugadores_fichas_en_casilla(this->ficha_sel->ruta[posicionrutacomida]);
  int idjugadorcomido=0;
  int idfichacomida=0;
  if (arr[0]!=-1 && arr[1]!=-1){
    idjugadorcomido=arr[0];
    idfichacomida=arr[1]; 
    this->jugadores[idjugadorcomido].fichas[idfichacomida].mover_posicion_ruta(posicionrutacomida,0);
    this->identificadorjugador->setTextura(eMoverFicha20);

    char tmp[1000];
    sprintf(tmp,"Ficha %s comida\n", this->jugadores[idjugadorcomido].nombrecolor);
    s->play_sound("share/glparchis/comer.wav");
    this->jugador_actual->TextoEventos_insertar(tmp);

//     this->ficha_sel->mover_posicion_ruta(posicionrutacomida);
    this->jugador_actual->ha_comido=true;
    return true;
  }
  return false;
}


/*!
    \fn Partida::llega_a_casa()
 */
bool Partida::llega_a_casa()
{
  if(this->ficha_sel->posicion_ruta+this->dado->tirada==72)
  {
    this->jugador_actual->ha_llegado_a_final=true;
  
    char tmp[1000];
    sprintf(tmp,"Ficha llega al final\n");
    printf("Ficha llega a final y cuenta 10\n");
    s->play_sound("share/glparchis/comer.wav");
    this->jugador_actual->TextoEventos_insertar(tmp);
    return true;
  }
return false;
}


/*!
    \fn Partida::mueve()
 */
bool Partida::mueve()
{
  int tirada=this->dado->tirada;
  if(this->ficha_sel->casillasamoverautomaticamente!=-1){
    tirada=this->ficha_sel->casillasamoverautomaticamente;
    this->ficha_sel->casillasamoverautomaticamente=-1;
  }
  
  if (this->ficha_sel->puedemover==true){
    printf("%s: Moviendo ficha (%d,%d) %d casillas (%d)\n",this->jugador_actual->nombrecolor, this->ficha_sel->id_jugador, this->ficha_sel->id, tirada,this->ficha_sel->puedemover);
    this->ficha_sel->mover(tirada);
    this->jugador_actual->ultima_ficha_movida=this->ficha_sel->id;
    if (this->jugador_actual->ha_comido==true){
      this->dado->tirada=20;
      this->jugador_actual->ha_comido=false;
    }
    if (this->jugador_actual->ha_llegado_a_final==true){
      this->dado->tirada=10;
      this->identificadorjugador->setTextura(eMoverFicha10);
      this->jugador_actual->ha_llegado_a_final=false;
    }
    return true;
  }

  printf("Ha seleccionado una ficha que no debía\n");
  return false;
}


/*!
    \fn Partida::tirando_dado()
 */
void Partida::tirando_dado()
{
  
        int tirada=this->dado->tirar(this->jugador_actual->tiene_todas_fichas_fuera(),this->jugador_actual->id);

  if (tirada==7 || tirada==6){
    this->jugador_actual->numero_seises++;
  } else {
    this->jugador_actual->numero_seises=0;
  }

  if (this->jugador_actual->numero_seises==3){
    this->jugador_actual->numero_seises=0;
    this->jugador_actual->a_casa_por_seises=true;
  }





        char tmp[1000];
        sprintf(tmp,"Ha sacado un %d.\n",this->dado->tirada);
        printf("%s: He sacado un %d.\n",this->jugador_actual->nombrecolor, this->dado->tirada);
        this->jugador_actual->TextoEventos_insertar(tmp, false);

//         this->jugador_actual->ha_tirado=true;
//         this->jugador_actual->analizando_resultado_dado(this->dado->tirada);
        if (this->jugador_actual->tipo_jugador==0 ){
		     s->play_sound("share/glparchis/dado.wav");
        }
//         this->before_clicking_any_ficha();


}


/*!
    \fn Partida::ia_emulate_dado()
 */
void Partida::ia_emulate_dado()
{
  printf ("%s: Emulando dado\n",this->jugador_actual->nombrecolor);
  after_clicking_dado();
}


/*!
    \fn Partida::ia_emulate_ficha()
 */
void Partida::ia_emulate_ficha()
{
  printf ("%s: Emulando ficha\n",this->jugador_actual->nombrecolor);
//   switch(this->jugador_actual->tipo_jugador){

//     default: //Se mantiene para el jugador 0
      JugFicha j;
      j.jugador=this->jugador_actual->id;
      int jugador_inicio_emulacion=this->jugador_actual->id;
      for (int i=0;i<4;i++){
        if(this->jugador_actual->id!=jugador_inicio_emulacion){
          break;
        }
        j.ficha=i;
        if (this->jugador_actual->fichas[i].puedemover==true){
           after_clicking_any_ficha(j);
           return;
        }
      }
      
//       break;

//   }
}


/*!
    \fn Partida::es_casilla_segura(int id_casilla)
 */
bool Partida::es_casilla_segura(int id_casilla)
{
   if (this->casillas[id_casilla].es_casilla_segura==true){
     if( this->jugador_actual->fichas[0].ruta[1]==id_casilla && this->casillas[id_casilla].numfichas>1){//Comer al salir. Debe ser mayor que uno porque debe haber una ficha del color que como para que pueda comer.
       return false; 
     }else{
       return true;
     }
   }else{
       return false;
   }
}

