/***************************************************************************
 *   Copyright (C) 2005 by MMM   *
 *   mamuma@eresmas.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "textura.h"

Textura::Textura()
{
  SDL_Color textColor = { 0, 0, 0 };
  font = TTF_OpenFont( "/usr/local/share/glparchis/Starsans.ttf", 200 );
    if( font == NULL )
    {
        printf("Error al cargar la textura Standard.ttf\n");

    }
  fontlazy = TTF_OpenFont( "/usr/local/share/glparchis/lazy.ttf", 200 );
    if( font == NULL )
    {
        printf("Error al cargar la textura lazy.ttf\n");

    }

  GLubyte fire[12] = { 
  0x00, 0x00, 0x00, 
  0xff, 0x00, 0x00, 
  0x00, 0xc0, 0x00, 
  0x00, 0x80, 0xff 
  };

  glGenTextures(NUM_TEXTURAS, this->textures);

  glBindTexture(GL_TEXTURE_2D, textures[0]);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE, GL_MODULATE);
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,2, 2, 0, GL_RGB, GL_UNSIGNED_BYTE, fire);


  LoadBitmap("share/glparchis/wood.bmp",1);
  LoadBitmap("share/glparchis/marco_casilla.bmp",2);

  #include "texturas/marco_casilla_inicio.xpm"
  loadtexture(marco_casilla_inicio_xpm,"Casilla Inicio", 3); 

  LoadBitmap("share/glparchis/marco_casilla_segura.bmp",4);

  #include "texturas/dado2.xpm"
  loadtexture(dado2_xpm, "Dado2",5);

  #include "texturas/dado3.xpm"
  loadtexture(dado3_xpm,"Dado3", 6);

  #include "texturas/dado4.xpm"
  loadtexture(dado4_xpm, "Dado4",7);

  #include "texturas/dado5.xpm"
  loadtexture(dado5_xpm, "Dado5", 8);

  #include "texturas/dado6.xpm"
  loadtexture(dado6_xpm, "Dado6" , 9);

  LoadBitmap("share/glparchis/dado_desplegado.bmp",10);
  LoadBitmap("share/glparchis/tirar_dado.bmp",11);
  char version[100];
  sprintf(version,"Version: %s",VERSION);
  TextureFromFont(version, fontlazy, 12);
  LoadBitmap("share/glparchis/gradiente.bmp",13);
  LoadBitmap("share/glparchis/moverficha.bmp",14);
  LoadBitmap("share/glparchis/volver_a_tirar.bmp",15);
  LoadBitmap("share/glparchis/mover_ficha_7.bmp",16);
  LoadBitmap("share/glparchis/mover_ficha_20.bmp",17);
  LoadBitmap("share/glparchis/mover_ficha_10.bmp",18);
  LoadBitmap("share/glparchis/pantallainicio.bmp",19);
  LoadBitmap("share/glparchis/pantallafinal.bmp",20);

  TextureFromFont(gettext("Jugar"), font, 21);
  TextureFromFont("Opciones", font, 22);
  TextureFromFont("Salir", font, 23);

//   GLfloat textcoord[4];
//   SDL_Surface *surface=;
//SDL_GL_LoadTexture(load_image("share/glparchis/fondo.png"),textcoord,23);

  TextureFromFont(gettext("Jugadores"), font, 24);
  TextureFromFont(gettext("Controles"), font, 25);
  TextureFromFont("Volver", font, 26);
  TextureFromFont("Creditos", font, 27);
  LoadBitmap("share/glparchis/marco_casilla_inicio_pc.bmp",28);
  LoadBitmap("share/glparchis/marco_casilla_inicio_human.bmp",29);
  LoadBitmap("share/glparchis/sinusuario.bmp",30);
  LoadBitmap("share/glparchis/marco_casilla_inicio_sin_usuario.bmp",31);

  glEnable(GL_TEXTURE_2D);

}


Textura::~Textura()
{
    TTF_CloseFont(font);
    TTF_CloseFont(fontlazy);
}

/*!
    \fn Textura::marco_casilla()
 */
GLuint Textura::marco_casilla()
{
    return textures[2];
}



struct sTexture * Textura::readxpm(char ** nombrevariable) {
	struct sTexture * text = (struct sTexture *) malloc(sizeof(struct sTexture));
	if (text != NULL) {
		int colors;
		int colorsize;

		sscanf(nombrevariable[0], "%d %d %d %d", &text->width, &text->height, &colors, &colorsize);

		text->data = malloc(text->width * text->height * 3);
		char * data = (char *)text->data;

		for (int y = 0; y < text->height; y++) {
			char * xpm = nombrevariable[colors + y + 1];
			for (int x = 0; x < text->width; x++) {
				int color = 0;

				for (int c = 0; c < colorsize; c++) {
					color = (color << 8) + *(xpm++);
				}

				for (int cs = 0; cs < colors; cs++) {
					int color2 = 0;
					for (int c = 0; c < colorsize; c++) {
						color2 = (color2 << 8) + nombrevariable[cs + 1][c];
					}
					if (color2 == color) {
						sscanf(strchr(nombrevariable[cs + 1], '#'), "#%2x%2x%2x", data, data+1, data+2);
						break;
					}
				}

				data += 3;
			}
		}
	}

	return text;
}
void Textura::loadtexture(char **nombrevariable,char *nombretextura, int idtextures) {
  sTexture * text = readxpm(nombrevariable);

  if (text != NULL) {
    glBindTexture(GL_TEXTURE_2D, textures[idtextures]);

    glTexImage2D(GL_TEXTURE_2D, 0, 3, text->width, text->height, 0, GL_RGB, GL_UNSIGNED_BYTE, text->data);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

    free(text->data);
    free(text);
//     printf("Se ha cargado la textura %s\n", nombretextura);
    return;
  }
  printf("No se ha podido abrir la textura %s\n",nombretextura);
}

/*!
    \fn Textura::madera()
 */
GLuint Textura::madera()
{
    return textures[1];
}


/*!
    \fn Textura::marco_casilla_inicio()
 */
GLuint Textura::marco_casilla_inicio()
{
    return textures[3];
}


int Textura::LoadBitmap(char *filename,int idtextures)
{
  char configprefix[1000];
  sprintf(configprefix,"%s",PREFIX);
  if (strcmp(configprefix,"NONE")==0){
    sprintf(configprefix,"/usr/local");
  }

//   printf("El prefijo de imagenes es %s\n",configprefix);
  char newfilename[1000];
  sprintf (newfilename,"%s/%s",configprefix,filename);

    FILE * file;
    char temp;
    long i;

    BITMAPINFOHEADER infoheader;


//     num_texture++; // The counter of the current texture is increased

    if( (file = fopen(newfilename, "rb"))==NULL){
       printf("No se ha podido abrir la textura %s\n",newfilename); 
       return (-1); // Open the file for reading
    }
    fseek(file, 18, SEEK_CUR);  /* start reading width & height */
    fread(&infoheader.biWidth, sizeof(int), 1, file);

    fread(&infoheader.biHeight, sizeof(int), 1, file);

    fread(&infoheader.biPlanes, sizeof(short int), 1, file);
    if (infoheader.biPlanes != 1) {
	    printf("Planes from %s is not 1: %u\n", newfilename, infoheader.biPlanes);
	    return 0;
    }

    // read the bpp
    fread(&infoheader.biBitCount, sizeof(unsigned short int), 1, file);
    if (infoheader.biBitCount != 24) {
      printf("Bpp from %s is not 24: %d\n", newfilename, infoheader.biBitCount);
      return 0;
    }

    fseek(file, 24, SEEK_CUR);

    // read the data.
    infoheader.data = (char *) malloc(infoheader.biWidth * infoheader.biHeight * 3);
    if (infoheader.data == NULL) {
	    printf("Error allocating memory for color-corrected image data\n");
	    return 0;
    }

    if ((i = fread(infoheader.data, infoheader.biWidth * infoheader.biHeight * 3, 1, file)) != 1) {
	    printf("Error reading image data from %s.\n", newfilename);
	    return 0;
    }

    for (i=0; i<(infoheader.biWidth * infoheader.biHeight * 3); i+=3) { // reverse all of the colors. (bgr -> rgb)
	    temp = infoheader.data[i];
	    infoheader.data[i] = infoheader.data[i+2];
	    infoheader.data[i+2] = temp;
    }


    fclose(file); // Closes the file stream

    glBindTexture(GL_TEXTURE_2D, textures[idtextures]);


    // Finally we define the 2d texture
    glTexImage2D(GL_TEXTURE_2D, 0, 3, infoheader.biWidth, infoheader.biHeight, 0, GL_RGB, GL_UNSIGNED_BYTE, infoheader.data);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    // And create 2d mipmaps for the minifying function
//     gluBuild2DMipmaps(GL_TEXTURE_2D, 3, infoheader.biWidth, infoheader.biHeight, GL_RGB, GL_UNSIGNED_BYTE, infoheader.data);
    
    free(infoheader.data); // Free the memory we used to load the texture
//     printf("Se ha cargado la textura %s\n", newfilename);
    return (idtextures); // Returns the current texture OpenGL ID
}

int Textura::power_of_two(int input)
{
    int value = 1;

    while ( value < input ) {
        value <<= 1;
    }
    return value;
}

GLuint Textura::SDL_GL_LoadTexture(SDL_Surface *surface, GLfloat *texcoord, int num_textura)
{
    int w, h;
    SDL_Surface *image;
    SDL_Rect area;
    Uint32 saved_flags;
    Uint8  saved_alpha;

    /* Use the surface width and height expanded to powers of 2 */
    w = power_of_two(surface->w);
    h = power_of_two(surface->h);
    texcoord[0] = 0.0f;         /* Min X */
    texcoord[1] = 0.0f;         /* Min Y */
    texcoord[2] = (GLfloat)surface->w / w;  /* Max X */
    texcoord[3] = (GLfloat)surface->h / h;  /* Max Y */

    image = SDL_CreateRGBSurface(
            SDL_SWSURFACE,
            w, h,
            32,
#if SDL_BYTEORDER == SDL_LIL_ENDIAN /* OpenGL RGBA masks */
            0x000000FF,
            0x0000FF00,
            0x00FF0000,
            0xFF000000
#else
            0xFF000000,
            0x00FF0000,
            0x0000FF00,
            0x000000FF
#endif
               );
    if ( image == NULL ) {
        return 0;
    }
//     image =load_image("share/glparchis/fondo.png");
//   SDL_Color textColor = { 255, 0, 0 };

    
//   image=TTF_RenderText_Blended( font, "Jugadores", textColor );
    /* Save the alpha blending attributes */
    saved_flags = surface->flags&(SDL_SRCALPHA|SDL_RLEACCELOK);
    saved_alpha = surface->format->alpha;
    if ( (saved_flags & SDL_SRCALPHA) == SDL_SRCALPHA ) {
        SDL_SetAlpha(surface, 0, 0);
    }

    /* Copy the surface into the GL texture image */
    area.x = 0;
    area.y = 0;
    area.w = surface->w;
    area.h = surface->h;
    SDL_BlitSurface(surface, &area, image, &area);

    /* Restore the alpha blending attributes */
    if ( (saved_flags & SDL_SRCALPHA) == SDL_SRCALPHA ) {
        SDL_SetAlpha(surface, saved_flags, saved_alpha);
    }

    /* Create an OpenGL texture for the image */
//     glGenTextures(1, &texture);
    glBindTexture(GL_TEXTURE_2D, this->textures[num_textura]);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexImage2D(GL_TEXTURE_2D,
             0,
             GL_RGBA,
             w, h,
             0,
             GL_RGBA,
             GL_UNSIGNED_BYTE,
             image->pixels);
    SDL_FreeSurface(image); /* No longer needed */
    return(num_textura);
}


SDL_Surface *Textura::load_image( const char * filename ) 
{
  char configprefix[1000];
  sprintf(configprefix,"%s",PREFIX);
  if (strcmp(configprefix,"NONE")==0){
    sprintf(configprefix,"/usr/local");
  }

//   printf("El prefijo de imagenes es %s\n",configprefix);
  char newfilename[1000];
  sprintf (newfilename,"%s/%s",configprefix,filename);


    //The image that's loaded
    SDL_Surface* loadedImage = NULL;
    
    //The optimized surface that will be used
    SDL_Surface* optimizedImage = NULL;
    
    //Load the image
    loadedImage = IMG_Load( newfilename );
    
    //If the image loaded
    if( loadedImage != NULL )
    {
        //Create an optimized surface
        optimizedImage = SDL_DisplayFormat( loadedImage );
        
        //Free the old surface
        SDL_FreeSurface( loadedImage );
        
        //If the surface was optimized
        if( optimizedImage != NULL )
        {
            //Color key surface
            SDL_SetColorKey( optimizedImage, SDL_RLEACCEL | SDL_SRCCOLORKEY, SDL_MapRGB( optimizedImage->format, 0, 0xFF, 0xFF ) );
        }
    }
    
    //Return the optimized surface
    return optimizedImage;
}

void Textura::TextureFromFont(char *text,
 TTF_Font *font,
 int num_textura)
 {
//  glDeleteTextures(1, &texID);
 SDL_Surface *initial;
 SDL_Surface *intermediary;
 SDL_Color white;
 
 #if SDL_BYTEORDER == SDL_BIG_ENDIAN
 uint masks[4] = { 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000 }; // set up for Big-Endian 
 #else
//  uint masks[4] = { 0xff000000, 0x000000ff, 0x0000ff00, 0x00ff0000 };
 uint masks[4] = { 0x00000000, 0x00000000, 0x00000000, 0x00000000 };
 #endif
 
 white.r = 255;
 white.g = 255;
 white.b = 255;
 
 initial = TTF_RenderText_Blended(font, text, white);
 
 intermediary = SDL_CreateRGBSurface(0, initial->w, initial->h, 32,
 masks[0], masks[1], masks[2], masks[3]);
 
 SDL_BlitSurface(initial, NULL, intermediary, NULL);
 /*
 glGenTextures(1, num_textura);*/
 glBindTexture(GL_TEXTURE_2D, this->textures[num_textura]);
 
 float largest_supported_anisotropy;
 glGetFloatv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, &largest_supported_anisotropy);
 glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, largest_supported_anisotropy);
 
 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
 
 gluBuild2DMipmaps(GL_TEXTURE_2D, 4, initial->w, initial->h, GL_RGBA, GL_UNSIGNED_BYTE, intermediary->pixels);
 
 SDL_FreeSurface(initial);
 SDL_FreeSurface(intermediary);
 }

