//
// C++ Implementation: x3d
//
// Description: 
//
//
// Author: Turulo <turulomio@yahoo.es>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "x3d.h"

x3d::x3d()
{

   eogl=new EntidadOpenGL[this->numero_EntidadOpenGL()];
}


x3d::~x3d()
{
}




/*!
    \fn x3d::leer_fichero()
 */
void x3d::leer_fichero()
{
    /// @todo implement me
   xmlNodePtr cur;
   xmlDocPtr doc;
        doc = xmlParseFile("/home/nobu/CVS/glparchis-20060201/src/3ds/blender.x3d");
        
        if (doc == NULL ) {
                fprintf(stderr,"Document not parsed successfully. \n");
                return;
        }

        cur = xmlDocGetRootElement(doc);
        
        if (cur == NULL) {
                fprintf(stderr,"empty document\n");
                xmlFreeDoc(doc);
                return;
        }

        if (xmlStrcmp(cur->name, (const xmlChar *) "X3D")) {
                fprintf(stderr,"document of the wrong type, root node != story");
                xmlFreeDoc(doc);
                return;
        }

        this->parseScene(doc,cur);
}

void x3d::parseScene(xmlDocPtr doc, xmlNodePtr cur) {
        cur = cur->xmlChildrenNode;
        while (cur != NULL) {
                 if ((!xmlStrcmp(cur->name, (const xmlChar *)"Scene"))){
                        printf("Scene detected\n");
                        for (int i=0;i<this->numero_EntidadOpenGL();i++)
                          parseTransform (&eogl[i],doc, cur);
                 }
                 cur = cur->next;
        }
        xmlFreeDoc(doc);

}

void
x3d::parseTransform (EntidadOpenGL *eogl,xmlDocPtr doc, xmlNodePtr cur) {
        cur = cur->xmlChildrenNode;
        while (cur != NULL) {
           if ((!xmlStrcmp(cur->name, (const xmlChar *)"Transform"))){
				  eogl->name=xmlGetProp(cur,(const xmlChar *)"DEF");
				  eogl->translation=xmlGetProp(cur,(const xmlChar *)"translation");
              printf("\n  * OpenGL Entity : %s\n", eogl->name);
              this->parseShape(eogl,doc,cur);
           }

           cur = cur->next;
        }
    return;
}



/*!
    \fn x3d::numero_EntidadOpenGL()
 */
int x3d::numero_EntidadOpenGL()
{
    /// @todo implement me
   return 2;
}


/*!
    \fn x3d::parseTransformAtributtes(xmlDocPtr doc, xmlNodePtr cur)
 */
void x3d::parseShape(EntidadOpenGL *eogl,xmlDocPtr doc, xmlNodePtr cur)
{
   cur = cur->xmlChildrenNode;
   while (cur != NULL) {
      if ((!xmlStrcmp(cur->name, (const xmlChar *)"Shape"))){
         printf("    + %s\n", cur->name);
         parseShapeChilds(eogl,doc,cur);
      }
      cur = cur->next;
   }
   return;
}

void x3d::parseShapeChilds(EntidadOpenGL *eogl,xmlDocPtr doc, xmlNodePtr cur)
{
   cur = cur->xmlChildrenNode;
   while (cur != NULL) {
      if ((!xmlStrcmp(cur->name, (const xmlChar *)"Appearance"))){
         printf("      = %s\n", cur->name);
      }
      if ((!xmlStrcmp(cur->name, (const xmlChar *)"IndexedFaceSet"))){
         printf("      = %s\n", cur->name);
         this->parseIndexedFaceSet(eogl,doc,cur);
      }
      cur = cur->next;
   }
   return;
}

void x3d::parseIndexedFaceSet (EntidadOpenGL *eogl,xmlDocPtr doc, xmlNodePtr cur){
   cur = cur->xmlChildrenNode;
   while (cur != NULL) {
      if ((!xmlStrcmp(cur->name, (const xmlChar *)"Coordinate"))){
				  eogl->strVertices=xmlGetProp(cur,(const xmlChar *)"point");
         printf("        - %s %s\n", cur->name, "");
      }
      if ((!xmlStrcmp(cur->name, (const xmlChar *)"TextureCoordinate"))){
				  eogl->strUV=xmlGetProp(cur,(const xmlChar *)"point");
         printf("        - %s %s\n", cur->name, "");
      }
      cur = cur->next;
   }
   return;
}


