//
// C++ Implementation: xml_glparchis
//
// Description: 
//
//
// Author: Turulo <turulomio@yahoo.es>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "xml_glparchis.h"

xml_glParchis::xml_glParchis(Partida *p)
{
  this->p=p;
}


xml_glParchis::~xml_glParchis()
{
}




/*!
    \fn xml_glParchis::save()
 */
bool xml_glParchis::save(char *file)
{
  FILE *f=fopen(file,"w");
  fputs("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n",f);
  fputs("<glParchis version=\"1.0\">\n",f);
  fputs("<partida>\n",f);
  fprintf(f,"  <jugadores numero=\"%d\" actual=\"%d\">\n",this->p->numero_jugadores, this->p->jugador_actual->id);
  fprintf(f,"    <jugador id=\"0\" nombre=\"azul\" tipo=\"%d\" activo=\"%s\">\n",this->p->jugadores[0].tipo_jugador, bool2string(this->p->jugadores[0].activo));
  fputs("      <fichas>\n",f);
  fprintf(f,"        <ficha id=\"0\" posicion_ruta=\"%d\" />\n",this->p->jugadores[0].fichas[0].posicion_ruta);
  fprintf(f,"        <ficha id=\"1\" posicion_ruta=\"%d\" />\n",this->p->jugadores[0].fichas[1].posicion_ruta);
  fprintf(f,"        <ficha id=\"2\" posicion_ruta=\"%d\" />\n",this->p->jugadores[0].fichas[2].posicion_ruta);
  fprintf(f,"        <ficha id=\"3\" posicion_ruta=\"%d\" />\n",this->p->jugadores[0].fichas[3].posicion_ruta);
  fputs("      </fichas>\n",f);
  fputs("    </jugador>\n",f);
  fprintf(f,"    <jugador id=\"1\" nombre=\"rojo\" tipo=\"%d\" activo=\"%s\">\n",this->p->jugadores[1].tipo_jugador, bool2string(this->p->jugadores[1].activo));
  fputs("      <fichas>\n",f);
  fprintf(f,"        <ficha id=\"0\" posicion_ruta=\"%d\" />\n",this->p->jugadores[1].fichas[0].posicion_ruta);
  fprintf(f,"        <ficha id=\"1\" posicion_ruta=\"%d\" />\n",this->p->jugadores[1].fichas[1].posicion_ruta);
  fprintf(f,"        <ficha id=\"2\" posicion_ruta=\"%d\" />\n",this->p->jugadores[1].fichas[2].posicion_ruta);
  fprintf(f,"        <ficha id=\"3\" posicion_ruta=\"%d\" />\n",this->p->jugadores[1].fichas[3].posicion_ruta);
  fputs("      </fichas>\n",f);
  fputs("    </jugador>\n",f);
  fprintf(f,"    <jugador id=\"2\" nombre=\"verde\" tipo=\"%d\" activo=\"%s\">\n",this->p->jugadores[2].tipo_jugador, bool2string(this->p->jugadores[2].activo));
  fputs("      <fichas>\n",f);
  fprintf(f,"        <ficha id=\"0\" posicion_ruta=\"%d\" />\n",this->p->jugadores[2].fichas[0].posicion_ruta);
  fprintf(f,"        <ficha id=\"1\" posicion_ruta=\"%d\" />\n",this->p->jugadores[2].fichas[1].posicion_ruta);
  fprintf(f,"        <ficha id=\"2\" posicion_ruta=\"%d\" />\n",this->p->jugadores[2].fichas[2].posicion_ruta);
  fprintf(f,"        <ficha id=\"3\" posicion_ruta=\"%d\" />\n",this->p->jugadores[2].fichas[3].posicion_ruta);
  fputs("      </fichas>\n",f);
  fputs("    </jugador>\n",f);
  fprintf(f,"    <jugador id=\"3\" nombre=\"amarillo\" tipo=\"%d\" activo=\"%s\">\n",this->p->jugadores[3].tipo_jugador, bool2string(this->p->jugadores[3].activo));
  printf("Se ha grabado %d\n",this->p->jugadores[3].activo);
  fputs("      <fichas>\n",f);
  fprintf(f,"        <ficha id=\"0\" posicion_ruta=\"%d\" />\n",this->p->jugadores[3].fichas[0].posicion_ruta);
  fprintf(f,"        <ficha id=\"1\" posicion_ruta=\"%d\" />\n",this->p->jugadores[3].fichas[1].posicion_ruta);
  fprintf(f,"        <ficha id=\"2\" posicion_ruta=\"%d\" />\n",this->p->jugadores[3].fichas[2].posicion_ruta);
  fprintf(f,"        <ficha id=\"3\" posicion_ruta=\"%d\" />\n",this->p->jugadores[3].fichas[3].posicion_ruta);
  fputs("      </fichas>\n",f);
  fputs("    </jugador>\n",f);
  fputs("  </jugadores>\n",f);

  fputs("</partida>\n",f);
  fputs("</glParchis>\n",f);
  fclose(f);
  printf("Partida saved en /tmp/glparchis.sav\n");
  return true;
}


/*!
    \fn xml_glParchis::load()
 */
void xml_glParchis::load(const char *fichero)
{  
  this->marcado_antes_load();

   xmlNodePtr cur;
   xmlDocPtr doc;
   doc = xmlParseFile(fichero);

   if (doc == NULL ) {
      fprintf(stderr,"Document not parsed successfully. \n");
      return;
   }

   cur = xmlDocGetRootElement(doc);

   if (cur == NULL) {
      fprintf(stderr,"empty document\n");
      xmlFreeDoc(doc);
      return;
   }

   if (xmlStrcmp(cur->name, (const xmlChar *) "glParchis")) {
      fprintf(stderr,"document of the wrong type, root node != story");
      xmlFreeDoc(doc);
      return;
   }

   printf("Cargando documento xml:glParchis %s\n", fichero);
   this->parsePartida(doc,cur);
}


void xml_glParchis::parsePartida(xmlDocPtr doc, xmlNodePtr cur)
{
        cur = cur->xmlChildrenNode;
        while (cur != NULL) {
                 if ((!xmlStrcmp(cur->name, (const xmlChar *)"partida"))){
                        parseJugadores (doc, cur);
                 }
                 cur = cur->next;
        }
        xmlFreeDoc(doc);
}


/*!
    \fn xml_glParchis::parseJugadores(xmlDocPtr doc, xmlNodePtr cur)
 */
void xml_glParchis::parseJugadores(xmlDocPtr doc, xmlNodePtr cur)
{
    cur = cur->xmlChildrenNode;
        while (cur != NULL) {
           if ((!xmlStrcmp(cur->name, (const xmlChar *)"jugadores"))){
				  this->p->numero_jugadores=atoi((const char *) xmlGetProp(cur,(const xmlChar *)"numero"));
				  int jugadoractual=atoi((const char *) xmlGetProp(cur,(const xmlChar *)"actual"));
              this->p->jugador_actual=&this->p->jugadores[jugadoractual];
              char cadena[100];
              sprintf(cadena,"Inicio de turno %s\n",this->p->jugador_actual->nombrecolor);
              this->p->jugador_actual->TextoEventos_insertar(cadena);
              this->parseJugador(doc,cur);
           }

           cur = cur->next;
        }
    return;
}


/*!
    \fn xml_glParchis::parseJugador(xmlDocPtr doc, xmlNodePtr cur)
 */
void xml_glParchis::parseJugador(xmlDocPtr doc, xmlNodePtr cur)
{ 
   cur = cur->xmlChildrenNode;
        while (cur != NULL) {
           if ((!xmlStrcmp(cur->name, (const xmlChar *)"jugador"))){
              int id=atoi((const char *) xmlGetProp(cur,(const xmlChar *)"id"));
//               printf("El id del jugador es %d\n",id);
              this->p->jugadores[id].id=id;
              sprintf(this->p->jugadores[id].nombrecolor,"%s",( char *) xmlGetProp(cur,(const xmlChar *)"nombre"));

              char activo[256];
               sprintf(activo,"%s",(const char *) xmlGetProp(cur,(const xmlChar *)"activo"));
//                printf ("Problema con activo %s con id %d \n",activo,id);
              this->p->jugadores[id].activo=string2bool(activo);
              this->p->jugadores[id].tipo_jugador=atoi((const char *) xmlGetProp(cur,(const xmlChar *)"tipo"));
              this->parseFichas(id,doc,cur);
           }
           cur = cur->next;
        }
    return;
}


/*!
    \fn xml_glParchis::parseFichas(xmlDocPtr doc, xmlNodePtr cur)
 */
void xml_glParchis::parseFichas(int idjugador, xmlDocPtr doc, xmlNodePtr cur)
{
   cur = cur->xmlChildrenNode;
        while (cur != NULL) {
           if ((!xmlStrcmp(cur->name, (const xmlChar *)"fichas"))){
//               printf("Fichas parseadas\n");
              this->parseFicha(idjugador,doc,cur);
           }

           cur = cur->next;
        }
    return;
}


/*!
    \fn xml_glParchis::parseFicha(xmlDocPtr doc, xmlNodePtr cur)
 */
void xml_glParchis::parseFicha(int idjugador,xmlDocPtr doc, xmlNodePtr cur)
{
   cur = cur->xmlChildrenNode;
        while (cur != NULL) {
           if ((!xmlStrcmp(cur->name, (const xmlChar *)"ficha"))){
              int idficha=atoi((const char *) xmlGetProp(cur,(const xmlChar *)"id"));
              this->p->jugadores[idjugador].fichas[idficha].id=idficha;
              int posicionruta_antescargar=this->p->jugadores[idjugador].fichas[idficha].posicion_ruta;
              this->p->jugadores[idjugador].fichas[idficha].posicion_ruta=atoi((const char *) xmlGetProp(cur,(const xmlChar *)"posicion_ruta"));
               int idcasilla=this->p->jugadores[idjugador].fichas[idficha].ruta[this->p->jugadores[idjugador].fichas[idficha].posicion_ruta];
//               this->p->casillas[idcasilla].ocupada_posicion_ficha_1=true;
              this->p->jugadores[idjugador].fichas[idficha].mover_posicion_ruta(posicionruta_antescargar, this->p->jugadores[idjugador].fichas[idficha].posicion_ruta);
              printf("Se ha colocado la ficha (%d,%d) en la casila %d, posicion %d. Venia de la posicion_ruta %d\n",idjugador,idficha,idcasilla,this->p->jugadores[idjugador].fichas[idficha].posicion_en_casilla, posicionruta_antescargar );
           }

           cur = cur->next;
        }

//     //Introduce barreras
//     if (this->p->jugadores[idjugador].fichas[0].id_casilla()==this->p->jugadores[idjugador].fichas[1].id_casilla())
// 		this->p->casillas[this->p->jugadores[idjugador].fichas[0].id_casilla()].tiene_barrera=true;
//     if (this->p->jugadores[idjugador].fichas[0].id_casilla()==this->p->jugadores[idjugador].fichas[2].id_casilla())
// 		this->p->casillas[this->p->jugadores[idjugador].fichas[0].id_casilla()].tiene_barrera=true;
//     if (this->p->jugadores[idjugador].fichas[0].id_casilla()==this->p->jugadores[idjugador].fichas[3].id_casilla())
// 		this->p->casillas[this->p->jugadores[idjugador].fichas[0].id_casilla()].tiene_barrera=true;
//     if (this->p->jugadores[idjugador].fichas[1].id_casilla()==this->p->jugadores[idjugador].fichas[2].id_casilla())
// 		this->p->casillas[this->p->jugadores[idjugador].fichas[1].id_casilla()].tiene_barrera=true;
//     if (this->p->jugadores[idjugador].fichas[1].id_casilla()==this->p->jugadores[idjugador].fichas[3].id_casilla())
// 		this->p->casillas[this->p->jugadores[idjugador].fichas[1].id_casilla()].tiene_barrera=true;
//     if (this->p->jugadores[idjugador].fichas[2].id_casilla()==this->p->jugadores[idjugador].fichas[3].id_casilla())
// 		this->p->casillas[this->p->jugadores[idjugador].fichas[2].id_casilla()].tiene_barrera=true;
//     return;
}


/*!
    \fn xml_glParchis::inicio_partida(int tipojugador1, int tipojugador2, int tipojugador3, int tipojugador4))
 */
void xml_glParchis::inicio_partida(int *tipojugador)
{
  //Saca el nmero de jugadores
  int numjugadores=4; //Siempre es 4 se debe controlar con  la inactividad
//   for (int i=0;i<4;i++){
//     if (tipojugador[i]==-1){
//       numjugadores--;
//     }
//   }
  //Saca el jugador actual
  int jugadoractual=0;
  for (int i=0;i<4;i++){
    if (tipojugador[i]!=-1){
      jugadoractual=i;
      break;
    }
  }

  //Saca la actividad de los jugadores
  bool actividad[4];
  for (int i=0;i<4;i++){
    if (tipojugador[i]!=-1)
      actividad[i]=true;
    else
      actividad[i]=false;
  }

  //Escribe el fichero
  FILE *f=fopen("/tmp/glparchis_inicio.sav","w");
  fputs("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n",f);
  fputs("<glParchis version=\"1.0\">\n",f);
  fputs("<partida>\n",f);
  fprintf(f,"  <jugadores numero=\"%d\" actual=\"%d\">\n",numjugadores, jugadoractual);
  fprintf(f,"    <jugador id=\"0\" nombre=\"azul\" tipo=\"%d\" activo=\"%s\">\n", tipojugador[0], bool2string(actividad[0]));
  fputs("      <fichas>\n",f);
  fprintf(f,"        <ficha id=\"0\" posicion_ruta=\"0\" />\n");
  fprintf(f,"        <ficha id=\"1\" posicion_ruta=\"0\" />\n");
  fprintf(f,"        <ficha id=\"2\" posicion_ruta=\"0\" />\n");
  fprintf(f,"        <ficha id=\"3\" posicion_ruta=\"0\" />\n");
  fputs("      </fichas>\n",f);
  fputs("    </jugador>\n",f);
  fprintf(f,"    <jugador id=\"1\" nombre=\"rojo\" tipo=\"%d\" activo=\"%s\">\n", tipojugador[1], bool2string(actividad[1]));
  fputs("      <fichas>\n",f);
  fprintf(f,"        <ficha id=\"0\" posicion_ruta=\"0\" />\n");
  fprintf(f,"        <ficha id=\"1\" posicion_ruta=\"0\" />\n");
  fprintf(f,"        <ficha id=\"2\" posicion_ruta=\"0\" />\n");
  fprintf(f,"        <ficha id=\"3\" posicion_ruta=\"0\" />\n");
  fputs("      </fichas>\n",f);
  fputs("    </jugador>\n",f);
  fprintf(f,"    <jugador id=\"2\" nombre=\"verde\" tipo=\"%d\" activo=\"%s\">\n", tipojugador[2], bool2string(actividad[2]));
  fputs("      <fichas>\n",f);
  fprintf(f,"        <ficha id=\"0\" posicion_ruta=\"0\" />\n");
  fprintf(f,"        <ficha id=\"1\" posicion_ruta=\"0\" />\n");
  fprintf(f,"        <ficha id=\"2\" posicion_ruta=\"0\" />\n");
  fprintf(f,"        <ficha id=\"3\" posicion_ruta=\"0\" />\n");
  fputs("      </fichas>\n",f);
  fputs("    </jugador>\n",f);
  fprintf(f,"    <jugador id=\"3\" nombre=\"amarillo\" tipo=\"%d\" activo=\"%s\">\n", tipojugador[3], bool2string(actividad[3]));
  fputs("      <fichas>\n",f);
  fprintf(f,"        <ficha id=\"0\" posicion_ruta=\"0\" />\n");
  fprintf(f,"        <ficha id=\"1\" posicion_ruta=\"0\" />\n");
  fprintf(f,"        <ficha id=\"2\" posicion_ruta=\"0\" />\n");
  fprintf(f,"        <ficha id=\"3\" posicion_ruta=\"0\" />\n");
  fputs("      </fichas>\n",f);
  fputs("    </jugador>\n",f);
  fputs("  </jugadores>\n",f);

  fputs("</partida>\n",f);
  fputs("</glParchis>\n",f);
  fclose(f);
  printf("Partida Inicial saved en /tmp/glparchis_inicio.sav\n");
}


/*!
    \fn xml_glParchis::string2bool(const char *)
 */
bool xml_glParchis::string2bool(const char *string)
{
   if(strcmp(string,"true")==0){
//      printf("La cadena coincide con true\n");
     return true;
   }
   if(strcmp(string,"false")==0){
//      printf("La cadena coincide con false\n");
     return false;
   } else {
     printf("La cadena no coincide ni con true ni con false\n");
     exit(0);
   }
}


/*!
    \fn xml_glParchis::bool2string(bool booleano)
 */
const char * xml_glParchis::bool2string(bool booleano)
{
   if(booleano==true){
     return "true";
   }
   if (booleano==false){
     return "false";
   }
   printf("El booleano no ha podido ser escrito a cadena\n");
   exit(0);
}
// void xml_glParchis::visualizar_variables()
// {
//   for (int i=0;i<4;i++){
// //     printf("La variable activo [%d] vale %d o %s\n",i,this->jugadores[i].activo,bool2string(this->jugadores[i].activo));
//   }
// }


/*!
    \fn xml_glParchis::marcado_antes_load()
 */
void xml_glParchis::marcado_antes_load()
{
   for(int i=0;i<this->p->tablero->numcasillas;i++){
      this->p->casillas[i].ocupada_posicion_ficha_1=false;
      this->p->casillas[i].ocupada_posicion_ficha_2=false;
      this->p->casillas[i].ocupada_posicion_ficha_3=false;
      this->p->casillas[i].ocupada_posicion_ficha_4=false;
      this->p->casillas[i].numfichas=0;
   }


   for (int i=0;i<4;i++){
      for (int j=0;j<4;j++){
         this->p->jugadores[i].fichas[j].posicion_ruta=68+j;
         this->p->jugadores[i].fichas[j].posicion_en_casilla=1;  
         int idcasilla=this->p->jugadores[i].fichas[j].ruta[68+j]; this->p->casillas[idcasilla].ocupada_posicion_ficha_1=true;
         this->p->jugadores[i].fichas[j].mover_posicion_ruta(68+j,68+j);
      }
   }
}
